#ifndef RENDERMANAGER_H
#define RENDERMANAGER_H

#include "face.h"
class ShaderManager;

class RenderManager
{
	private:
		ShaderManager * shaderManager;
		bool fog;
		float fog_color[3];
		float fog_density;
	public:
		RenderManager(ShaderManager*);
		void RenderFaceGroup(FaceGroup * pFgrp);
		void FaceGroupUnregisterBuffers(FaceGroup * facegrp);
		void FaceGroupRegisterBuffers(FaceGroup * facegrp);
		void FaceGroupRender(FaceGroup * facegrp);
		bool isShaderCapable(void);
		bool isVertexBufferCapable(void);
		bool isMultitextureCapable(void);
		void enableDepthTest(bool);
		void enableBlending(bool enable);
		void setFog(float density,float r,float g, float b);
		void enableFog(bool value);
};



#endif /*RENDERMANAGER_H*/
