#ifndef FACE_H
#define FACE_H

#include "BufferManager.h"
/*
class face
{
	public:
	int vertexindex[4];
	char nbvertices;
	unsigned int textureids[2];
	int nbtextures;
	float textCoords[8];
	float normal[3];
	float color[4][3];
};
*/

typedef struct 
{
	int vertexindex[4];
	char nbvertices;
	unsigned int textureids[2];
	int nbtextures;
	float texCoords[8];
	float normal[3];
	float color[4][3];
	//float normals[4][3];
	//float binormals[4][3];	
	//float tangents[4][3];
	bool useNormalMap;
}face;


typedef struct
{
	//float position[4];
	bool hasTexture;
	bool hasNormalMap;
	int faceCount;
	int textureids[4];
	int texturesCount;
	bool useShader;
	int shaderProgram;
	int texCoordsCount;
	int verticesPerFace;
	int verticesCount;
	int texCoordsLayerCount;
	bool useDynamicLight;
	bool useSoftwareTransform;
	DWORD * pVertBuffer;
	int uVertBufferOffset;
	DWORD * pFaceIndexBuffer;	
	int uFaceIndexBufferOffset;	
	DWORD * pTexCoordsBuffer;
	int uTexCoordsBuffer;		
	DWORD * pColorBuffer;
	int uColorBuffer;	
	DWORD * pNormalBuffer;
	DWORD * pUVMapBuffer;
	int uUVMapCount;
	float position[3];
	float rotation[3];
	unsigned int elementBufferName;
	unsigned int vertexBufferName;
	unsigned int texcoordsBufferName;
	unsigned int colorBufferName;	
	
} FaceGroup;

void FaceGroupAddFaceIndexItem(FaceGroup * fgrp,int size,int * faceindex);
void FaceGroupAddVertexItem(FaceGroup * fgrp,int size,float * vertex);
void FaceGroupAddTriangle(FaceGroup * facegrp,float * a,float * b,float *c);

void computeNormal(face * pface, float ** vertexbuffer);
void computeLocalSpace(face * pface, float **vertexbuffer, float **normalbuffer,float **binormalbuffer, float **tangentbuffer);
void computeLocalSpace2(face * pface, float **vertexbuffer, float **normalbuffer,float **binormalbuffer, float **tangentbuffer);
void computeLocalSpaceVertex(float *normalbuffer,float *binormalbuffer, float *tangentbuffer);
#endif
