#ifndef MATRIX33F_H
#define MATRIX33F_H

#include "vector3f.h"
class matrix33f
{
  private :
	  float t[9];
  public :
  matrix33f(const float mat[9]);
  matrix33f();
  ~matrix33f();
  float & operator() (int i,int j);
  float & operator() (int i);
  matrix33f operator * (matrix33f m);
  vector3f operator * (vector3f v);
  static void add(matrix33f & result,matrix33f m1, matrix33f m2);
  static void sub(matrix33f & result,matrix33f m1, matrix33f m2);	
  static void mul(matrix33f & result,matrix33f m1, matrix33f m2);
  static matrix33f get_identitymatrix();
  static matrix33f get_rotationmatrix(float ax,float ay,float az);
};

#endif



