//
// File: object.h
// Created by: User <Email>
// Created on: Wed Nov 24 22:58:18 2004
//

#ifndef _OBJECT_H_
#define _OBJECT_H_

#include "face.h"


class ObjectMaterial;
class ObjectShape
{
public:
	float **vertices;
	float **normals;
	float **binormals;
	float **tangents;
	int vertexcount;
};

class object
{
	public:
		object(float,float,float);
		 ~object();
		virtual void draw(void);
		virtual void render(void);
		void activate();
		void desactivate();
		bool is_activate();
		float * get_position(void);
	 	float * get_orientation(void);
 	    void set_position(float x,float y,float z);
 	    void set_orientation(float a_x,float a_y,float z);
	 	bool is_listable(void);
	 	void set_listable(bool b);
	 	int get_idlist(void);
	 	void set_idlist(int);
	 	bool is_collisionable(void);
	 	void set_collisionable(bool);
	 	virtual bool collision_resolve(float *);
        virtual void translate(void);
        virtual void rotate(void);
		float **vertices;
		int vertexcount;
		int facecount;
		face * arrayface;
		float **normals;
		float **binormals;
		float **tangents;
		float *texcoords;
		int textureCount;
		char name[30];
		//char ** textureNames;

		//int textureid[8];
		int texcoordscount;
		bool hasNormalMap;
		bool hasShadow;
		int verticesPerFace;
		FaceGroup * arrayfacegroup;
		int facegroupcount;
		//bool hasShader;
		//char shader_prog[256];
		//unsigned int shader_prog_id;
		//void set_texture(char * name);
		//void set_shader(char * filename);
	protected:
		float position[3];
		float orientation[3];
		bool activated;
		bool listable;
		int idlist;
		bool collisionable;

};


#endif	//_OBJECT_H_
