#include "BmpFontManager.h"
#include "quad.h"
#include "engine.h"
#include "ei.h"
#include <stdio.h>
#include "texture2d.h"

BmpFontManager::BmpFontManager(engine * poEngine)
{
  this->poEngine = poEngine;
  this->iQuadCount = 0;
  this->iFontTextureID = 0;
  this->vQuadList = new Quad*[1000];

  this->vCharCoord['-'][0][0] = 0.;
  this->vCharCoord['-'][0][1] = 0.;
  this->vCharCoord['-'][1][0] = 15./320.;
  this->vCharCoord['-'][1][1] = 16./52.;

  this->vCharCoord['.'][0][0] = 16./320.;
  this->vCharCoord['.'][0][1] = 0./52.;
  this->vCharCoord['.'][1][0] = 30./320.;
  this->vCharCoord['.'][1][1] = 16./52.;

  this->vCharCoord['!'][0][0] = 32./320.;
  this->vCharCoord['!'][0][1] = 0./52.;
  this->vCharCoord['!'][1][0] = 47./320.;
  this->vCharCoord['!'][1][1] = 16./52.;

  this->vCharCoord['0'][0][0] = 48./320.;
  this->vCharCoord['0'][0][1] = 0./52.;
  this->vCharCoord['0'][1][0] = 63./320.;
  this->vCharCoord['0'][1][1] = 16./52.;

  this->vCharCoord['1'][0][0] = 64./320.;
  this->vCharCoord['1'][0][1] = 0./52.;
  this->vCharCoord['1'][1][0] = 79./320.;
  this->vCharCoord['1'][1][1] = 16./52.;

  this->vCharCoord['2'][0][0] = 80./320.;
  this->vCharCoord['2'][0][1] = 0./52.;
  this->vCharCoord['2'][1][0] = 95./320.;
  this->vCharCoord['2'][1][1] = 16./52.;

  this->vCharCoord['3'][0][0] = 96./320.;
  this->vCharCoord['3'][0][1] = 0./52.;
  this->vCharCoord['3'][1][0] = 111./320.;
  this->vCharCoord['3'][1][1] = 16./52.;

  this->vCharCoord['4'][0][0] = 112./320.;
  this->vCharCoord['4'][0][1] = 0./52.;
  this->vCharCoord['4'][1][0] = 128./320.;
  this->vCharCoord['4'][1][1] = 16./52.;

  this->vCharCoord['5'][0][0] = 129./320.;
  this->vCharCoord['5'][0][1] = 0./52.;
  this->vCharCoord['5'][1][0] = 143./320.;
  this->vCharCoord['5'][1][1] = 16./52.;

  this->vCharCoord['6'][0][0] = 144./320.;
  this->vCharCoord['6'][0][1] = 0./52.;
  this->vCharCoord['6'][1][0] = 159./320.;
  this->vCharCoord['6'][1][1] = 16./52.;

  this->vCharCoord['7'][0][0] = 160./320.;
  this->vCharCoord['7'][0][1] = 0./52.;
  this->vCharCoord['7'][1][0] = 175./320.;
  this->vCharCoord['7'][1][1] = 16./52.;

  this->vCharCoord['8'][0][0] = 176./320.;
  this->vCharCoord['8'][0][1] = 0./52.;
  this->vCharCoord['8'][1][0] = 191./320.;
  this->vCharCoord['8'][1][1] = 16./52.;

  this->vCharCoord['9'][0][0] = 192./320.;
  this->vCharCoord['9'][0][1] = 0./52.;
  this->vCharCoord['9'][1][0] = 207./320.;
  this->vCharCoord['9'][1][1] = 16./52.;


  this->vCharCoord[':'][0][0] = 208./320.;
  this->vCharCoord[':'][0][1] = 0./52.;
  this->vCharCoord[':'][1][0] = 223./320.;
  this->vCharCoord[':'][1][1] = 16./52.;

  this->vCharCoord['\''][0][0] = 224./320.;
  this->vCharCoord['\''][0][1] = 0./52.;
  this->vCharCoord['\''][1][0] = 239./320.;
  this->vCharCoord['\''][1][1] = 16./52.;

  this->vCharCoord['('][0][0] = 240./320.;
  this->vCharCoord['('][0][1] = 0./52.;
  this->vCharCoord['('][1][0] = 255./320.;
  this->vCharCoord['('][1][1] = 16./52.;

  this->vCharCoord[')'][0][0] = 256./320.;
  this->vCharCoord[')'][0][1] = 0./52.;
  this->vCharCoord[')'][1][0] = 271./320.;
  this->vCharCoord[')'][1][1] = 16./52.;

  this->vCharCoord[','][0][0] = 272./320.;
  this->vCharCoord[','][0][1] = 0./52.;
  this->vCharCoord[','][1][0] = 287./320.;
  this->vCharCoord[','][1][1] = 16./52.;

  this->vCharCoord['?'][0][0] = 288./320.;
  this->vCharCoord['?'][0][1] = 0./52.;
  this->vCharCoord['?'][1][0] = 303./320.;
  this->vCharCoord['?'][1][1] = 16./52.;

  this->vCharCoord[' '][0][0] = 304./320.;
  this->vCharCoord[' '][0][1] = 0./52.;
  this->vCharCoord[' '][1][0] = 320./320.;
  this->vCharCoord[' '][1][1] = 16./52.;


  this->vCharCoord['A'][0][0] = 0./320.;
  this->vCharCoord['A'][0][1] = 17./52.;
  this->vCharCoord['A'][1][0] = 15./320.;
  this->vCharCoord['A'][1][1] = 32./52.;

  this->vCharCoord['B'][0][0] = 16./320.;
  this->vCharCoord['B'][0][1] = 17./52.;
  this->vCharCoord['B'][1][0] = 30./320.;
  this->vCharCoord['B'][1][1] = 32./52.;

  this->vCharCoord['C'][0][0] = 32./320.;
  this->vCharCoord['C'][0][1] = 17./52.;
  this->vCharCoord['C'][1][0] = 47./320.;
  this->vCharCoord['C'][1][1] = 32./52.;

  this->vCharCoord['D'][0][0] = 48./320.;
  this->vCharCoord['D'][0][1] = 17./52.;
  this->vCharCoord['D'][1][0] = 63./320.;
  this->vCharCoord['D'][1][1] = 32./52.;

  this->vCharCoord['E'][0][0] = 64./320.;
  this->vCharCoord['E'][0][1] = 17./52.;
  this->vCharCoord['E'][1][0] = 79./320.;
  this->vCharCoord['E'][1][1] = 32./52.;

  this->vCharCoord['F'][0][0] = 80./320.;
  this->vCharCoord['F'][0][1] = 17./52.;
  this->vCharCoord['F'][1][0] = 95./320.;
  this->vCharCoord['F'][1][1] = 32./52.;

  this->vCharCoord['G'][0][0] = 96./320.;
  this->vCharCoord['G'][0][1] = 17./52.;
  this->vCharCoord['G'][1][0] = 111./320.;
  this->vCharCoord['G'][1][1] = 32./52.;

  this->vCharCoord['H'][0][0] = 112./320.;
  this->vCharCoord['H'][0][1] = 17./52.;
  this->vCharCoord['H'][1][0] = 128./320.;
  this->vCharCoord['H'][1][1] = 32./52.;

  this->vCharCoord['I'][0][0] = 129./320.;
  this->vCharCoord['I'][0][1] = 17./52.;
  this->vCharCoord['I'][1][0] = 143./320.;
  this->vCharCoord['I'][1][1] = 32./52.;

  this->vCharCoord['J'][0][0] = 144./320.;
  this->vCharCoord['J'][0][1] = 17./52.;
  this->vCharCoord['J'][1][0] = 159./320.;
  this->vCharCoord['J'][1][1] = 32./52.;

  this->vCharCoord['K'][0][0] = 160./320.;
  this->vCharCoord['K'][0][1] = 17./52.;
  this->vCharCoord['K'][1][0] = 175./320.;
  this->vCharCoord['K'][1][1] = 32./52.;

  this->vCharCoord['L'][0][0] = 176./320.;
  this->vCharCoord['L'][0][1] = 17./52.;
  this->vCharCoord['L'][1][0] = 191./320.;
  this->vCharCoord['L'][1][1] = 32./52.;

  this->vCharCoord['M'][0][0] = 192./320.;
  this->vCharCoord['M'][0][1] = 17./52.;
  this->vCharCoord['M'][1][0] = 207./320.;
  this->vCharCoord['M'][1][1] = 32./52.;


  this->vCharCoord['N'][0][0] = 208./320.;
  this->vCharCoord['N'][0][1] = 17./52.;
  this->vCharCoord['N'][1][0] = 223./320.;
  this->vCharCoord['N'][1][1] = 32./52.;

  this->vCharCoord['O'][0][0] = 224./320.;
  this->vCharCoord['O'][0][1] = 17./52.;
  this->vCharCoord['O'][1][0] = 239./320.;
  this->vCharCoord['O'][1][1] = 32./52.;

  this->vCharCoord['P'][0][0] = 240./320.;
  this->vCharCoord['P'][0][1] = 17./52.;
  this->vCharCoord['P'][1][0] = 255./320.;
  this->vCharCoord['P'][1][1] = 32./52.;

  this->vCharCoord['Q'][0][0] = 256./320.;
  this->vCharCoord['Q'][0][1] = 17./52.;
  this->vCharCoord['Q'][1][0] = 271./320.;
  this->vCharCoord['Q'][1][1] = 32./52.;

  this->vCharCoord['R'][0][0] = 272./320.;
  this->vCharCoord['R'][0][1] = 17./52.;
  this->vCharCoord['R'][1][0] = 287./320.;
  this->vCharCoord['R'][1][1] = 32./52.;

  this->vCharCoord['S'][0][0] = 288./320.;
  this->vCharCoord['S'][0][1] = 17./52.;
  this->vCharCoord['S'][1][0] = 303./320.;
  this->vCharCoord['S'][1][1] = 32./52.;

  this->vCharCoord['T'][0][0] = 304./320.;
  this->vCharCoord['T'][0][1] = 17./52.;
  this->vCharCoord['T'][1][0] = 320./320.;
  this->vCharCoord['T'][1][1] = 32./52.;

  this->vCharCoord['U'][0][0] = 0./320.;
  this->vCharCoord['U'][0][1] = 34./52.;
  this->vCharCoord['U'][1][0] = 15./320.;
  this->vCharCoord['U'][1][1] = 50./52.;

  this->vCharCoord['V'][0][0] = 16./320.;
  this->vCharCoord['V'][0][1] = 34./52.;
  this->vCharCoord['V'][1][0] = 30./320.;
  this->vCharCoord['V'][1][1] = 50./52.;

  this->vCharCoord['W'][0][0] = 32./320.;
  this->vCharCoord['W'][0][1] = 34./52.;
  this->vCharCoord['W'][1][0] = 47./320.;
  this->vCharCoord['W'][1][1] = 50./52.;

  this->vCharCoord['X'][0][0] = 48./320.;
  this->vCharCoord['X'][0][1] = 34./52.;
  this->vCharCoord['X'][1][0] = 63./320.;
  this->vCharCoord['X'][1][1] = 50./52.;

  this->vCharCoord['Y'][0][0] = 64./320.;
  this->vCharCoord['Y'][0][1] = 34./52.;
  this->vCharCoord['Y'][1][0] = 79./320.;
  this->vCharCoord['Y'][1][1] = 50./52.;

  this->vCharCoord['Z'][0][0] = 80./320.;
  this->vCharCoord['Z'][0][1] = 34./52.;
  this->vCharCoord['Z'][1][0] = 95./320.;
  this->vCharCoord['Z'][1][1] = 50./52.;
}
BmpFontManager::~BmpFontManager()
{
  
}
int BmpFontManager::LoadBmpFont(char * sFileName)
{
  int i = this->poEngine->add_texture(sFileName);
  Texture2D * poTexture = this->poEngine->get_texture_from_index(i);
  poTexture->set_coloralphavalue(0,0,0,0);
  return this->iFontTextureID = this->poEngine->bind_texture(i);
}
int BmpFontManager::DisplayText(const char * sText, float fX, float fY, float fSize)
{
  for (int i = 0; sText[i] != 0;i++)
  {
     Quad * poQuad = new Quad(fX + (i*fSize),fY,fX-fSize + (i*fSize),fY-fSize,-5.);
     //printf("Texture %d\n",this->iFontTextureID);
     char c = 0;
     c = sText[i];
     poQuad->settexture(this->iFontTextureID);
     poQuad->setTexCoordTop(this->vCharCoord[c][0][0],this->vCharCoord[c][0][1]);
     poQuad->setTexCoordBottom(this->vCharCoord[c][1][0],this->vCharCoord[c][1][1]);

    this->vQuadList[this->iQuadCount] = poQuad;
     this->iQuadCount++;
  }
  return 0;
}


void BmpFontManager::Render()
{
  //EI_testrender();
EI_enable_blending();
  for (int i = 0;i < this->iQuadCount;i++)
    this->vQuadList[i]->render();
EI_disable_blending();
}

void BmpFontManager::Clear()
{
  for (int i = 0;i < this->iQuadCount;i++)
  {
    delete this->vQuadList[i];
  }
  this->iQuadCount = 0;
}
