#include "RenderManager.h"
#include "ei.h"
#include "ShaderManager.h"
#include <stdlib.h>

RenderManager::RenderManager(ShaderManager* shaderManager)
{
	this->shaderManager = shaderManager;
}


void RenderManager::FaceGroupRender(FaceGroup * facegrp)
{
	if (this->fog == true)
	{
			EI_enable_fog();

	}else EI_disable_fog();

	//this->FaceGroupPrint(facegrp);
      EI_push_matrix();

	for (int i = 0;i < facegrp->texturesCount;i++)
	{
		EI_set_active_texture(i);
		EI_bind_2D_texture(facegrp->textureids[i]);
	}

	//Rendu multi-passe de l'eclairage global
	if (facegrp->hasNormalMap)
	{

	}

	if (facegrp->useShader)
	{

		this->shaderManager->bind_shader(facegrp->shaderProgram);
    	EI_translate(facegrp->position[0],facegrp->position[1],facegrp->position[2]);
        EI_rotate(facegrp->rotation[0],facegrp->rotation[1],facegrp->rotation[2]);
	}
	else
	if (!facegrp->useSoftwareTransform)
	{
    	EI_translate(facegrp->position[0],facegrp->position[1],facegrp->position[2]);
        EI_rotate(facegrp->rotation[0],facegrp->rotation[1],facegrp->rotation[2]);
	}
	/*
	{
    	EI_translate(facegrp->position[0],facegrp->position[1],facegrp->position[2]);
        EI_rotate(facegrp->rotation[0],facegrp->rotation[1],facegrp->rotation[2]);
        //EI_rotate(90.,0,0);
	}
	*/

	//printf("kikoo %d\n",facegrp->texturesCount);
	if (facegrp->verticesPerFace == 3)
	EI_render_triangle(facegrp->elementBufferName,facegrp->vertexBufferName,facegrp->texcoordsBufferName,
		facegrp->colorBufferName,facegrp->faceCount,facegrp->texturesCount);

	if (facegrp->useShader)
	{
		this->shaderManager->bind_shader(0);
	}


	for (int i = 0;i < facegrp->texturesCount;i++)
	{
		EI_set_inactive_texture(i);
	}


      EI_pop_matrix();
}


void RenderManager::FaceGroupRegisterBuffers(FaceGroup * facegrp)
{
	unsigned int * pFacesIndex;
	float * pVertices;
	float * pColors;
	float * pTexCoords;
	if ((facegrp->faceCount > 0)&&(facegrp->verticesCount > 0))
	{

		//pFacesIndex = this->bufferFaceIndex + sizeof(int)*facegrp->faceCount;
		pFacesIndex = (unsigned int*)facegrp->pFaceIndexBuffer;
		EI_RegisterFaceBuffer(&facegrp->elementBufferName,sizeof(int)*facegrp->faceCount*facegrp->verticesPerFace,pFacesIndex);
		//printf("Element Buffer Name %d\n",facegrp->elementBufferName);
		//pVertices = this->bufferVertices + sizeof(float)*facegrp->verticesCount;
		pVertices = (float*)facegrp->pVertBuffer;
		EI_RegisterVertexBuffer(&facegrp->vertexBufferName,facegrp->verticesCount*3*sizeof(float),pVertices);

		if (facegrp->pColorBuffer != NULL)
		{
			pColors = (float*)facegrp->pColorBuffer;
			//pColors = (float*)facegrp->pNormalBuffer;
			EI_RegisterColorBuffer(&facegrp->colorBufferName,facegrp->verticesCount*3*sizeof(float),pColors);
		}

		if (facegrp->pUVMapBuffer != NULL)
		{
			pTexCoords = (float*)facegrp->pUVMapBuffer;
			EI_RegisterTexCoordsBuffer(&facegrp->texcoordsBufferName,facegrp->verticesCount*2*sizeof(float),pTexCoords);
		}
	}
}

void RenderManager::FaceGroupUnregisterBuffers(FaceGroup * facegrp)
{
	if (facegrp->elementBufferName != 0)
	{
		EI_UnregisterFaceBuffer(facegrp->elementBufferName);
	}

	if (facegrp->vertexBufferName != 0)
	{
		EI_UnregisterVertexBuffer(facegrp->vertexBufferName);
	}


	if (facegrp->colorBufferName != 0)
	{
		EI_UnregisterColorBuffer(facegrp->colorBufferName);
	}

	if (facegrp->texcoordsBufferName != 0)
	{
		EI_UnregisterTexCoordsBuffer(facegrp->texcoordsBufferName);
	}
}

void RenderManager::enableDepthTest(bool enable)
{
	if (enable)
	{
		EI_enable_depthtest();
	} else EI_disable_depthtest();

}

void RenderManager::enableBlending(bool enable)
{
	if (enable)
	{
		EI_enable_blending();
	} else EI_disable_blending();

}

void RenderManager::setFog(float density,float r,float g, float b)
{
	EI_set_fog(density,r,g,b);
}

void RenderManager::enableFog(bool value)
{
	this->fog = value;
}

