#include "SoundManager.h"
#include <SDL/SDL.h>
#include <stdlib.h>
#include <SDL/SDL_mixer.h>


SoundManager::SoundManager()
{
  int i;
  for (i = 0;i < AUDIOMAX;i++)
  {
    this->vAudioData[i] = NULL;
  }
}

SoundManager::~SoundManager()
{
}

int SoundManager::Init(void)
{
    // open 44.1KHz, signed 16bit, system byte order,
    //      stereo audio, using 1024 byte chunks
    
    //if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 1024)==-1) {
if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 4096)==-1) {
      printf("Mix_OpenAudio: %s\n", Mix_GetError());
      exit(2);
    }
    Mix_VolumeMusic(50);

}

int SoundManager::Close(void)
{
    Mix_CloseAudio();
}

int SoundManager::LoadAudio(char * sFileName)
{

  // load sample.wav in to sample
  Mix_Chunk *sample;
  sample=Mix_LoadWAV(sFileName);
  if(!sample) {
    printf("Mix_LoadWAV: %s\n", Mix_GetError());
     // handle error
  }

    for (int i = 0;i < AUDIOMAX;i++)
    {
        if (this->vAudioData[i] == NULL)
        {
          this->vAudioData[i] = sample;
          return i;
        }
    }
    return -1;

}

int SoundManager::LoadMusic(char * sFileName)
{
    // load the MP3 file "music.mp3" to play as music
    Mix_Music *music;
    music=Mix_LoadMUS(sFileName);
    
    if(!music) {
       printf("Mix_LoadMUS(\"music.mp3\"): %s\n", Mix_GetError());
       // this might be a critical error...
       return -1;
    }

    for (int i = 0;i < AUDIOMAX;i++)
    {
        if (this->vAudioData[i] == NULL)
        {
          this->vAudioData[i] = music;
          return i;
        }
    }
    return -1;
}


int SoundManager::UnloadAudio(int iAudioID)
{
}

int SoundManager::PlayAudio(char * sFileName)
{
}

int SoundManager::PlayAudio(int iAudioID)
{

  Mix_Chunk *sample;
  sample = (Mix_Chunk *)this->vAudioData[iAudioID];

  // play sample on first free unreserved channel
  // play it exactly once through
  // Mix_Chunk *sample; //previously loaded
  if(Mix_PlayChannel(-1, sample, 0)==-1) {
    printf("Mix_PlayChannel: %s\n",Mix_GetError());
    // may be critical error, or maybe just no channels were free.
    // you could allocated another channel in that case...
  }

}

int SoundManager::PlayMusic(int iMusicID,int iLoops)
{
  Mix_Music *music;
  music = (Mix_Music *)this->vAudioData[iMusicID];
  // play music forever
  // Mix_Music *music; // I assume this has been loaded already
  if(Mix_PlayMusic(music, iLoops)==-1) {
    printf("Mix_PlayMusic: %s\n", Mix_GetError());
    // well, there's no music, but most games don't break without music...
  }

}
