#include "SpriteManager.h"
#include <stdio.h>
#include "ei.h"
#include "quad.h"
#include "engine.h"

SpriteManager::SpriteManager(engine * poEngine)
{
  this->poEngine = poEngine;
  this->vQuadList = new Quad*[SPRITEMAX];
  for (int i = 0;i < SPRITEMAX;i++)
    this->vQuadList[i] = NULL;
}

SpriteManager::~SpriteManager()
{
  for (int i = 0;i < SPRITEMAX;i++)
  {
    if (this->vQuadList[i] != NULL)
    {
       delete this->vQuadList[i];
    }
  } 
}

void SpriteManager::Render()
{
EI_enable_blending();
  for (int i = 0;i < SPRITEMAX;i++)
  {
    if (this->vQuadList[i] != NULL)
    {
       this->vQuadList[i]->render();  
     }  
  }
EI_disable_blending();
}

int SpriteManager::CreateSprite(int iTextureID, float fX, float fY, float fZ, float fWidth
      , float fHeight)
{

  for (int i = 0;i < SPRITEMAX;i++)
  {
    if (this->vQuadList[i] == NULL)
    {

  Quad * poQuad = new Quad(fX - fWidth/2., fY - fHeight / 2., 
       fX + fWidth / 2., fY + fHeight/ 2.,fZ);

     poQuad->set_orientation(0.,180.,0.);
//  Quad * poQuad = new Quad(fX + fWidth/2., fY + fHeight / 2., 
//       fX - fWidth / 2., fY - fHeight/ 2.,fZ);
     // printf("Create Quad %f %f - %f %f Z= %f\n", fX - fWidth/2., fY - fHeight / 2., 
     //  fX + fWidth / 2., fY + fHeight/ 2., fZ);
      // this->poEngine->add_object((object*)poQuad);
/*
  Quad * poQuad = new Quad(0.,0., -10.,-10.,0.);  
       
*/
       this->vQuadList[i] = poQuad;
       poQuad->settexture(iTextureID);
       return i;
    }
  } 
  return -1;
}

int SpriteManager::RemoveSprite(int iSpriteID)
{
  if (this->vQuadList[iSpriteID] == NULL)
    return -1;
 // this->poEngine->remove_object(this->vQuadList[iSpriteID]);   
  delete this->vQuadList[iSpriteID];
  this->vQuadList[iSpriteID] = NULL;
  return 0;
}

float * SpriteManager::GetSpritePosition(int iSpriteID)
{
  return this->vQuadList[iSpriteID]->get_position();
}

float * SpriteManager::GetSpriteOrientation(int iSpriteID)
{
  return this->vQuadList[iSpriteID]->get_orientation();
}
