#include "TextureManager.h"
#include <stdio.h>
#include <string.h>

#include <SDL/SDL.h>
#include "ei.h"

TextureManager::TextureManager(int size)
{
	this->arrTexture = new t_texture*[size];	
	this->size = size;
	for (int i = 0;i < size;i++)
	{
		this->arrTexture[i] = NULL;
	}
}

int TextureManager::add_texture(char *filename)
{
	for (int i = 0;i < this->size;i++)
	{
		if (this->arrTexture[i] != NULL)
		
			if (!strcmp(filename,this->arrTexture[i]->sFilename))
			{
				return this->arrTexture[i]->iName;
			}	
	}

	for (int i = 0;i < this->size;i++)
	{
		if (this->arrTexture[i] == NULL)
		{
			this->arrTexture[i] = new t_texture;
			SDL_Surface * surface = SDL_LoadBMP(filename);
			if (surface == NULL)
			{
				printf("Cannot Load BMP %s\n",filename);
				return 0;
			}
			
  			int w = surface->w;
  			int h = surface->h;
  			int bpp = surface->format->BitsPerPixel;
  			int size = bpp/4;
  			unsigned char * pixels = (unsigned char*) surface->pixels;			
				
    		EI_gen_textures(1,&this->arrTexture[i]->iName);
    		EI_bind_2D_texture(this->arrTexture[i]->iName);
    		if (bpp == 32)
    			EI_tex_image2d32(pixels,w,h,this->arrTexture[i]->iName);	
    		else EI_tex_image2d24(pixels,w,h,this->arrTexture[i]->iName);	
    		
    		printf("texture created\n");
    		delete surface;
    		return 	this->arrTexture[i]->iName;
		}		
		
	}
	//printf("No space left for texture\n");
	return 0;
}

void remove_texture(char *filename)
{
		
}

void bind_texture(int texturename)
{
	
}	