//
// File: camera.cc
// Created by: User <Email>
// Created on: Thu Nov 25 19:23:26 2004
//

#include "camera.h"
#include "math.h"

camera::camera()
{
	this->position[0] = 0;
	this->position[1] = 0;
	this->position[2] = 0.;
	this->orientation[0] = -90.;
	this->orientation[1] = 0;
	this->orientation[2] = 0;
			
}


camera::~camera()
{
	// TODO: put destructor code here
}

void camera::translate_x(float x){
  this->position[0] += x;
}
void camera::translate_y(float y){
  this->position[1] += y;
}
void camera::translate_z(float z){
  this->position[2] += z;
}
void camera::rotate_x(float a){
  this->orientation[0] += a;
}
void camera::rotate_y(float a){
  this->orientation[1] += a;
}
void camera::rotate_z(float a){
  this->orientation[2] += a;
}
float * camera::get_position(void){
  return this->position;
}    
float * camera::get_orientation(void){
  return this->orientation;
}    
//#include <stdio.h>
float * camera::get_vector(void){
  static float vVect[3];
  static float fdeg2rad = 3.14 / 180.;
  
   vVect[2] = cos(this->orientation[2] * fdeg2rad);
  vVect[0] = cos(this->orientation[0] * fdeg2rad);
  vVect[1] = cos(this->orientation[1] * fdeg2rad); 
  /*
  vVect[2] = 1 / cos(this->orientation[0] * fdeg2rad);
  vVect[0] = 1 / cos(this->orientation[1] * fdeg2rad);
  vVect[1] = 1 / cos(this->orientation[2] * fdeg2rad);
  */
  
  /*
  vVect[2] = sin(this->orientation[1] * fdeg2rad) + cos(this->orientation[0] * fdeg2rad);
  vVect[0] = cos(this->orientation[2] * fdeg2rad) + sin(this->orientation[1] * fdeg2rad);
  vVect[1] = cos(this->orientation[2] * fdeg2rad) + sin(this->orientation[2] * fdeg2rad);
  */
  
  /*
  vVect[0] = sin(this->orientation[1] * fdeg2rad) + cos(this->orientation[2] * fdeg2rad);
  vVect[1] = cos(this->orientation[0] * fdeg2rad) + sin(this->orientation[2] * fdeg2rad);
  vVect[2] = sin(this->orientation[0] * fdeg2rad) + cos(this->orientation[1] * fdeg2rad);
*/
  vVect[0] = vVect[0];
  vVect[1] = vVect[1];
  vVect[2] = vVect[2];
  //printf("vect: x %f y %f z %f\n",vVect[0],vVect[1],vVect[2]);
  return vVect;
}

void camera::set_position(float x,float y,float z)
{
	this->position[0] = x;
	this->position[1] = y;
	this->position[2] = z;
  
}
void camera::set_orientation(float a_x,float a_y,float a_z)
{
	this->orientation[0] = a_x;
	this->orientation[1] = a_y;
	this->orientation[2] = a_z;
}

