#include "cube.h"
#include "ei.h"


cube::cube(float size,float x,float y,float z) : mobile(2,x,y,z)
{
  this->size = size;
	
       this->vertices =new float*[8];
       for (int k = 0;k < 8;k++)
       {
	       this->vertices[k] = new float[3];
	       this->vertices[k][0] = 0.;
	       this->vertices[k][1] = 0.;
	       this->vertices[k][2] = 0.;	       
       }

       this->normals =new float*[8];
       for (int k = 0;k < 8;k++)
       {
	       this->normals[k] = new float[3];	
	       this->normals[k][0] = 0.;
	       this->normals[k][1] = 0.;
	       this->normals[k][2] = 0.;	       
       }
       
       this->binormals =new float*[8];
       for (int k = 0;k < 8;k++)
       {
	       this->binormals[k] = new float[3];
	       this->binormals[k][0] = 0.;
	       this->binormals[k][1] = 0.;
	       this->binormals[k][2] = 0.;	       
       }	       
       
        this->tangents =new float*[8];
       for (int k = 0;k < 8;k++)
       {
	       this->tangents[k] = new float[3];
	       this->tangents[k][0] = 0.;
	       this->tangents[k][1] = 0.;
	       this->tangents[k][2] = 0.;	       
       }	             
       
  this->vertices[0][0] = -1./2.;
  this->vertices[0][1] = -1./2.;
  this->vertices[0][2] = -1./2.;

  this->vertices[1][0] = -1./2.;
  this->vertices[1][1] = +1./2.;
  this->vertices[1][2] = -1./2.;

  this->vertices[2][0] = +1./2.;
  this->vertices[2][1] = +1./2.;
  this->vertices[2][2] = -1./2.;

  this->vertices[3][0] = +1./2.;
  this->vertices[3][1] = -1./2.;
  this->vertices[3][2] = -1./2.; 

  this->vertices[4][0] = -1./2.;
  this->vertices[4][1] = -1./2.;
  this->vertices[4][2] = +1./2.;

  this->vertices[5][0] = -1./2.;
  this->vertices[5][1] = +1./2.;
  this->vertices[5][2] = +1./2.;

  this->vertices[6][0] = +1./2.;
  this->vertices[6][1] = +1./2.;
  this->vertices[6][2] = +1./2.;

  this->vertices[7][0] = +1./2.;
  this->vertices[7][1] = -1./2.;
  this->vertices[7][2] = +1./2.;           

/*
  this->angularspeed[0] = 0.;
  this->angularspeed[1] = 0.;
  this->angularspeed[2] = 0.;
*/
}

cube::cube(float size,float mass,float x,float y,float z): mobile(mass,x,y,z){
  //cube(size,x,y,z);
  this->mass = mass;
  this->size = size;
  this->vertices[0][0] = -1./2.;
  this->vertices[0][1] = -1./2.;
  this->vertices[0][2] = -1./2.;

  this->vertices[1][0] = -1./2.;
  this->vertices[1][1] = +1./2.;
  this->vertices[1][2] = -1./2.;

  this->vertices[2][0] = +1./2.;
  this->vertices[2][1] = +1./2.;
  this->vertices[2][2] = -1./2.;

  this->vertices[3][0] = +1./2.;
  this->vertices[3][1] = -1./2.;
  this->vertices[3][2] = -1./2.; 

  this->vertices[4][0] = -1./2.;
  this->vertices[4][1] = -1./2.;
  this->vertices[4][2] = +1./2.;

  this->vertices[5][0] = -1./2.;
  this->vertices[5][1] = +1./2.;
  this->vertices[5][2] = +1./2.;

  this->vertices[6][0] = +1./2.;
  this->vertices[6][1] = +1./2.;
  this->vertices[6][2] = +1./2.;

  this->vertices[7][0] = +1./2.;
  this->vertices[7][1] = -1./2.;
  this->vertices[7][2] = +1./2.; 
}

cube::~cube()
{
}

void cube::set_color(float r, float g, float b){
  this->color[0] = r;
  this->color[1] = g;
  this->color[2] = b;
  
}

void cube::draw(void)
{
  EI_begin_quad();
  EI_normal(0,0,-1);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);

  EI_normal(0,0,1);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 

  EI_normal(1,0,0);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);

  EI_normal(0,-1,0);  
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]); 

EI_normal(-1,0,0); 
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]); 

  EI_normal(0,1,0); 
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 

  EI_end();
}
#include <stdio.h>
void cube::render(){      
      if (this->is_listable()){
        EI_scale(this->size,this->size,this->size);
        EI_setcolor(this->color[0],this->color[1],this->color[2]);
        EI_call_list(this->get_idlist());
      }
      else {
        EI_scale(this->size,this->size,this->size);
        EI_setcolor(this->color[0],this->color[1],this->color[2]);
           this->draw();
           } 
}
void cube::rotate(void)
{
       //EI_push_matrix();
       EI_translate(this->get_position()[0],
                  this->get_position()[1],
                  this->get_position()[2]);      
}
void cube::translate(void)
{
         EI_rotate(this->get_orientation()[0],
                this->get_orientation()[1],
                this->get_orientation()[2]); 
           
}


