//#include "ei.h"
//#define ARE_SDL
#ifndef ARE_SDL
#include <GL/glew.h>
#endif
#include <GL/gl.h>
#include <GL/glu.h>
//#include <GL/glext.h>

#ifdef ARE_SDL
	#include <SDL/SDL.h>
#endif
//#include <SDL.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>


//OpenGL Extensions
#ifdef ARE_SDL
PFNGLGENBUFFERSARBPROC glGenBuffers;
PFNGLBINDBUFFERARBPROC glBindBuffer;
PFNGLBUFFERDATAARBPROC glBufferData;
PFNGLDELETEBUFFERSARBPROC glDeleteBuffers;
PFNGLGENPROGRAMSARBPROC glGenProgramsARB;
PFNGLBINDPROGRAMARBPROC glBindProgramARB;
PFNGLPROGRAMSTRINGARBPROC glProgramStringARB;
#endif
//PFNGLMULTITEXCOORD2FARBPROC		glMultiTexCoord2f;
//PFNGLMULTITEXCOORD3FARBPROC		glMultiTexCoord3f;
//PFNGLMULTITEXCOORD4FARBPROC		glMultiTexCoord4f;
//PFNGLACTIVETEXTUREARBPROC		glActiveTexture;
//PFNGLCLIENTACTIVETEXTUREARBPROC	glClientActiveTexture;

//External variables provided by the interface
char EI_mouse_down = 0;
char EI_mouse_up =0;
char EI_mouse_left = 0;
char EI_mouse_right = 0;
char EI_keyb_down = 0;
char EI_keyb_up = 0;
char EI_keyb_left = 0;
char EI_keyb_right = 0;
char EI_keyb_space = 0;
char EI_keyb_esc = 0;

//#define OPENGLDEBUG

static void setup_opengl( int width, int height );
static void process_events( void );

void EI_draw_triangle(float s1[3],float s2[3],float s3[3]){
  glBegin(GL_TRIANGLES);
  glVertex3f(s1[0],s1[1],s1[2]);
  glVertex3f(s2[0],s2[1],s2[2]);
  glVertex3f(s3[0],s3[1],s3[2]);
  glEnd();
}

void EI_begin_triangle(void){
  glBegin(GL_TRIANGLES);
}

void EI_begin_quad(void){
	glBegin(GL_QUADS);
	//puts("BEGIN");
	if (glGetError() != 0)
		printf("Error %d\n",glGetError());
}

void EI_begin_quadstrip(void){
  glBegin(GL_QUAD_STRIP);
}


void EI_normal(float x,float y,float z){
  glNormal3f(x,y,z);
}


void EI_vertex(float x,float y,float z){
	glVertex3f(x,y,z);
	if (glGetError() != 0)
		printf("Error %d\n",glGetError());
}

void EI_scale(float sx,float sy,float sz){
  glScalef(sx,sy,sz);
}

void EI_end(void){
	glEnd();
	//puts("END");
	/*
	int error;
	if (error = glGetError() != 0)
	{
		switch(error)
		{
			case GL_INVALID_OPERATION : puts("GL_INVALID_OPERATION");break;
			default : printf("GL Error %d\n",error);
		}
	}
	*/
}

void EI_enable_texture(void){
  //glColor3f(1.,1.,1.);
  glEnable(GL_TEXTURE_2D);
}

void EI_setcolor(float r,float g,float b){
  // glDisable(GL_TEXTURE_2D);
  glColor3f(r,g,b);
}

void EI_init(int w, int h, int f){
#ifdef ARE_SDL
  if ( SDL_Init( SDL_INIT_JOYSTICK ) < 0 ) {
    fprintf(stderr, "Impossible d'initialiser SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);
  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
     SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 8);
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
SDL_Surface *screen;
	SDL_WM_SetCaption("Open your mind to Another Reality !",NULL);
	if (f)
      screen = SDL_SetVideoMode(w, h, 32, SDL_OPENGL|SDL_FULLSCREEN);
    else screen = SDL_SetVideoMode(w, h, 32, SDL_OPENGL);
    if ( screen == NULL ) {
        fprintf(stderr, "Impossible de changer le mode video: %s\n", SDL_GetError());
        exit(1);
    }

 #endif
	setup_opengl( w, h);

}
void EI_close(){
}
void EI_mainloop(){
    //while( 1 ) {
        /* Process incoming events. */
        process_events( );
        /* Draw the screen. */
     //   draw_screen( );
    //}
}
#ifdef ARE_SDL
void handle_mouse_motion(SDL_MouseMotionEvent * mm)
{
  static int pre_x, pre_y;
  if (mm->x < pre_x)
    EI_mouse_left = 1;
  else EI_mouse_left = 0;
  if (mm->x > pre_x)
    EI_mouse_right = 1;
  else EI_mouse_right = 0;
  if (mm->y < pre_y)
    EI_mouse_down = 1;
  else EI_mouse_down = 0;
  if (mm->y > pre_y)
    EI_mouse_up = 1;
  else EI_mouse_up = 0;
  pre_x = mm->x;
  pre_y = mm->y;
}
#endif

static void process_events( void )
{
#ifdef ARE_SDL
       static int grabed = 0;
    /* Our SDL event placeholder. */
    SDL_Event event;
    SDL_KeyboardEvent * ke;
    /*
    EI_mouse_down = 0;
    EI_mouse_up =0;
    EI_mouse_left = 0;
    EI_mouse_right = 0;
    EI_keyb_down = 0;
    EI_keyb_up = 0;
    EI_keyb_left = 0;
    EI_keyb_right = 0;
    EI_keyb_space = 0;
    EI_keyb_esc = 0;
    */
    /* Grab all the events off the queue. */
    while( SDL_PollEvent( &event ) ) {

        switch( event.type ) {
        case SDL_KEYDOWN:
            /* Handle key presses. */
            //handle_key_down( &event.key.keysym );
            //EI_keyb_down = 1;
            switch(event.key.keysym.sym){
                case SDLK_DOWN : EI_keyb_down = 1;break;
                case SDLK_UP : EI_keyb_up = 1;break;
                case SDLK_SPACE : EI_keyb_space = 1;break;
                case SDLK_LEFT : EI_keyb_left = 1;break;
                case SDLK_RIGHT : EI_keyb_right = 1;break;
                case SDLK_ESCAPE : EI_keyb_esc = 1;
                                   SDL_Quit();
                                   exit(0);
                                   break;
              }
            //SDL_Quit();
		 	//exit(0);
            break;
        case SDL_KEYUP:
            /* Handle key presses. */
            //handle_key_down( &event.key.keysym );
            //ke = (SDL_KeyboardEvent *)&event;
            //ke->keysym =
            /*
            switch(event.key.keysym.sym==SD)
              EI_keyb_up = 1;*/
            //SDL_Quit();
		 	//exit(0);

            switch(event.key.keysym.sym){
                case SDLK_DOWN : EI_keyb_down = 0;break;
                case SDLK_UP : EI_keyb_up = 0;break;
                case SDLK_SPACE : EI_keyb_space = 0;break;
                case SDLK_LEFT : EI_keyb_left = 0;break;
                case SDLK_RIGHT : EI_keyb_right = 0;break;
                case SDLK_ESCAPE : EI_keyb_esc = 0;
                                   SDL_Quit();
                                   exit(0);
                                   break;
              }
            break;
      //  case SDL_KEYESC:
      //      break;

        case SDL_MOUSEMOTION:
             if (grabed == 1)
                handle_mouse_motion(&event.motion);
              break;
        case SDL_MOUSEBUTTONDOWN:
             if (!grabed){
                if (event.button.button == SDL_BUTTON_LEFT){
                   grabed = 1;
                   SDL_WM_GrabInput(SDL_GRAB_ON);
                   SDL_ShowCursor(0);
                }
             }
             else
                if(event.button.button == SDL_BUTTON_RIGHT){
                  grabed = 0;
                  SDL_WM_GrabInput(SDL_GRAB_OFF);
                  SDL_ShowCursor(1);
                     }
             break;
        case SDL_QUIT:
            /* Handle quit requests (like Ctrl-c). */
            SDL_Quit();
		 	exit(0);
            break;
        }

    }
 #endif

}

void EI_render_triangle_buffer(float * vertexarray, float * texcoordsarray,int texturecount,float * colorarray,int size)
{

	GLuint bufname[3];
	bufname[0]= 0;
	bufname[1]= 0;
	bufname[2]= 0;
	glGenBuffers(3,bufname);

	glBindBuffer(GL_ARRAY_BUFFER,bufname[0]);
	glBufferData(GL_ARRAY_BUFFER,size*3*3*sizeof(float),vertexarray,GL_DYNAMIC_DRAW);
	glVertexPointer(3,GL_FLOAT,0,0);

	glBindBuffer(GL_ARRAY_BUFFER,bufname[1]);
	glBufferData(GL_ARRAY_BUFFER,size*3*3*sizeof(float),colorarray,GL_DYNAMIC_DRAW);
	glColorPointer(3,GL_FLOAT,0,(char*)NULL);
	glEnableClientState(GL_COLOR_ARRAY);

	if (texturecount > 0){
		glBindBuffer(GL_ARRAY_BUFFER,bufname[2]);
		glBufferData(GL_ARRAY_BUFFER,size*2*3*texturecount*sizeof(float),texcoordsarray,GL_DYNAMIC_DRAW);
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			glTexCoordPointer(2,GL_FLOAT,0,((char*)NULL + (12*i)));
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		}
	}

	glEnableClientState(GL_VERTEX_ARRAY);

	glDrawArrays(GL_TRIANGLES,0,size*3);

	if (texturecount > 0)
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		}

	glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
	glDeleteBuffers(3, bufname);
}

void EI_render_triangle_buffer_with_cubemap(float * vertexarray, float * texcoordsarray,float * texcubemap,int texturecount,int size)
{

	GLuint bufname[3];
	bufname[0]= 0;
	bufname[3]= 0;
    glGenBuffers(3,bufname);

    glBindBuffer(GL_ARRAY_BUFFER,bufname[0]);
 glBufferData(GL_ARRAY_BUFFER,size*3*3*sizeof(float),vertexarray,GL_DYNAMIC_DRAW);
    glVertexPointer(3,GL_FLOAT,0,0);


    glBindBuffer(GL_ARRAY_BUFFER,bufname[1]);
   glBufferData(GL_ARRAY_BUFFER,size*3*3*sizeof(float),texcubemap,GL_DYNAMIC_DRAW);
		glClientActiveTexture(GL_TEXTURE0);

   glTexCoordPointer(3,GL_FLOAT,0,(char*)NULL);

glEnableClientState(GL_TEXTURE_COORD_ARRAY);

    if (texturecount > 0)
    {

	glBindBuffer(GL_ARRAY_BUFFER,bufname[2]);
	glBufferData(GL_ARRAY_BUFFER,size*2*3*texturecount*sizeof(float),texcoordsarray,GL_DYNAMIC_DRAW);
	for (int i = 0; i < texturecount;i++)
	{
		glClientActiveTexture(GL_TEXTURE0 + i + 1);
		glTexCoordPointer(2,GL_FLOAT,0,((char*)NULL + (12*i)));
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	}

    }

   glEnableClientState(GL_VERTEX_ARRAY);



    glDrawArrays(GL_QUADS,0,size*3);

if (texturecount > 0)
    for (int i = 0; i < texturecount;i++)
    {
	glClientActiveTexture(GL_TEXTURE0+i + 1);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    }
    glDisableClientState(GL_VERTEX_ARRAY);
    glDeleteBuffers(3, bufname);
}


void EI_render_triangle_buffer_with_shader(float * vertexarray, float * texcoordsarray, float * colorarray,int texturecount,
					int size,unsigned int vertexProgramId,unsigned int fragmentProgramId)
{
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE,GL_ONE);
	glDepthMask(GL_FALSE);

	// on active les vertex/fragment program
	glEnable(GL_VERTEX_PROGRAM_ARB);
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB,vertexProgramId);
	glEnable(GL_FRAGMENT_PROGRAM_ARB);
	glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB,fragmentProgramId);

	GLuint bufname[3];
	bufname[0]= 0;
	bufname[1]= 0;
	bufname[2]= 0;
	glGenBuffers(3,bufname);

	glBindBuffer(GL_ARRAY_BUFFER,bufname[0]);
	glBufferData(GL_ARRAY_BUFFER,size*3*3*sizeof(float),vertexarray,GL_DYNAMIC_DRAW);
	glVertexPointer(3,GL_FLOAT,0,(char*)NULL);
 	glEnableClientState(GL_VERTEX_ARRAY);


	glBindBuffer(GL_ARRAY_BUFFER,bufname[1]);
	glBufferData(GL_ARRAY_BUFFER,size*3*3*sizeof(float),colorarray,GL_DYNAMIC_DRAW);
	glColorPointer(3,GL_FLOAT,0,(char*)NULL);
	glEnableClientState(GL_COLOR_ARRAY);

	if (texturecount > 0)
	{
		glBindBuffer(GL_ARRAY_BUFFER,bufname[2]);
		glBufferData(GL_ARRAY_BUFFER,size*3*4*texturecount*sizeof(float),texcoordsarray,GL_DYNAMIC_DRAW);
		for (int i = 0; i < texturecount;i++)
		{
			//printf("texturecount:%d\n",GL_TEXTURE1);
			glClientActiveTexture(GL_TEXTURE0+i);
			//glTexCoordPointer(2,GL_FLOAT,0,(char*)NULL + 1*size*2*4*sizeof(float));

			//glTexCoordPointer(4,GL_FLOAT,0,((char*)NULL + (4*sizeof(float)*i)));
			glTexCoordPointer(4,GL_FLOAT,0,((char*)NULL + (48*i)));
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		}
	}



	glDrawArrays(GL_TRIANGLES,0,size*3);


	if (texturecount > 0)
	for (int i = 0; i < texturecount;i++)
	{
		glClientActiveTexture(GL_TEXTURE0+i);
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	}

	glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);

	glDeleteBuffers(3, bufname);


	glDisable(GL_FRAGMENT_PROGRAM_ARB);
	// on desactive les vertex/fragment program
	glDisable(GL_VERTEX_PROGRAM_ARB);

	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_TRUE);
}

void EI_set_active_texture0(void)
{
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
}

void EI_set_active_texture1(void)
{
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glEnable(GL_TEXTURE_2D);
}

void EI_set_inactive_texture1(void)
{
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glDisable(GL_TEXTURE_2D);
}

void EI_set_inactive_texture0(void)
{
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glDisable(GL_TEXTURE_2D);
}

void EI_set_inactive_texture(int i)
{
	glActiveTextureARB(GL_TEXTURE0_ARB + i);
	glDisable(GL_TEXTURE_2D);
}


void EI_set_active_texture(int i)
{
	glActiveTextureARB(GL_TEXTURE0_ARB + i);
	glEnable(GL_TEXTURE_2D);
}

void EI_RegisterVertexBuffer(unsigned int * bufName,unsigned int byteSize,float * vertexbuffer)
{
	//printf("EI_RegisterVertexBuffer %d\n",byteSize);
	glGenBuffers(1,bufName);


	/*
	for(int i = 0;i < (byteSize/(sizeof(float)));i++)
	{
		printf(" %f ",vertexbuffer[i]);
	}
	*/

	glBindBuffer(GL_ARRAY_BUFFER,*bufName);
	glBufferData(GL_ARRAY_BUFFER,byteSize,vertexbuffer,GL_DYNAMIC_DRAW);
}

void EI_UnregisterVertexBuffer(unsigned int bufName)
{
	glDeleteBuffers(1,&bufName);
}

void EI_RegisterColorBuffer(unsigned int * bufName,unsigned int byteSize,float * colorbuffer)
{
	glGenBuffers(1,bufName);

	glBindBuffer(GL_ARRAY_BUFFER,*bufName);
	glBufferData(GL_ARRAY_BUFFER,byteSize,colorbuffer,GL_DYNAMIC_DRAW);
}

void EI_UnregisterColorBuffer(unsigned int bufName)
{
	glDeleteBuffers(1,&bufName);
}


void EI_RegisterTexCoordsBuffer(unsigned int * bufName,unsigned int byteSize,float * texcoordbuffer)
{
	glGenBuffers(1,bufName);

	glBindBuffer(GL_ARRAY_BUFFER,*bufName);
	glBufferData(GL_ARRAY_BUFFER,byteSize,texcoordbuffer,GL_DYNAMIC_DRAW);
}

void EI_UnregisterTexCoordsBuffer(unsigned int bufName)
{
	glDeleteBuffers(1,&bufName);
}

//static unsigned int * fb;

void EI_RegisterFaceBuffer(unsigned int * bufName,unsigned int byteSize,unsigned int * facebuffer)
{
	//printf("EI_RegisterFaceBuffer %d\n",byteSize);
	/*
	for(int i = 0;i < (byteSize/(sizeof(int)));i++)
	{
		printf(" %d ",facebuffer[i]);
	}
	puts("");
	*/
	//fb = facebuffer;
	glGenBuffers(1,bufName);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,*bufName);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER,byteSize,facebuffer,GL_DYNAMIC_DRAW);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
}

void EI_UnregisterFaceBuffer(unsigned int bufName)
{
	glDeleteBuffers(1,&bufName);
}

void EI_render_triangle(unsigned int elementBufferName,unsigned int vertexBufferName,unsigned int texcoordsBufferName,
unsigned int colorBufferName,unsigned int size,unsigned int texturecount)
{
	//printf("%d %d %d %d %d %d\n",elementBufferName,vertexBufferName,texcoordsBufferName,colorBufferName,size,texturecount);

	//unsigned int data[] = {0,1,2,3,4,5,6,7,8,9,10,11,12};

	glBindBuffer(GL_ARRAY_BUFFER,vertexBufferName);
	glVertexPointer(3,GL_FLOAT,0,0);
	glEnableClientState(GL_VERTEX_ARRAY);

	if (colorBufferName != 0)
	{
		glBindBuffer(GL_ARRAY_BUFFER,colorBufferName);
		glColorPointer(3,GL_FLOAT,0,(char*)NULL);
		glEnableClientState(GL_COLOR_ARRAY);
	}

	if (texturecount > 0){
		glBindBuffer(GL_ARRAY_BUFFER,texcoordsBufferName);
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			glTexCoordPointer(2,GL_FLOAT,0,((char*)NULL + (12*i)));
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		}
	}
	else
	{
		glActiveTextureARB(GL_TEXTURE0_ARB);
		glDisable(GL_TEXTURE_2D);
	}

	if(elementBufferName != 0)
	{
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, elementBufferName);
		glDrawElements(GL_TRIANGLES,size*3,GL_UNSIGNED_INT, (char*)NULL);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
	}
	else
	{
		glDrawArrays(GL_TRIANGLES,0,size*3);
	}

	if (texturecount > 0)
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		}

	if (colorBufferName != 0)
		glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
}


void EI_render_quad(unsigned int elementBufferName,unsigned int vertexBufferName,unsigned int texcoordsBufferName,
unsigned int colorBufferName,unsigned int size,unsigned int texturecount)
{
	//printf("%d %d %d %d %d %d\n",elementBufferName,vertexBufferName,texcoordsBufferName,colorBufferName,size,texturecount);

	//unsigned int data[] = {0,1,2,3,4,5,6,7,8,9,10,11,12};

	glBindBuffer(GL_ARRAY_BUFFER,vertexBufferName);
	glVertexPointer(3,GL_FLOAT,0,0);
	glEnableClientState(GL_VERTEX_ARRAY);

	if (colorBufferName != 0)
	{
		glBindBuffer(GL_ARRAY_BUFFER,colorBufferName);
		glColorPointer(3,GL_FLOAT,0,(char*)NULL);
		glEnableClientState(GL_COLOR_ARRAY);
	}

	if (texturecount > 0){
		glBindBuffer(GL_ARRAY_BUFFER,texcoordsBufferName);
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			glTexCoordPointer(2,GL_FLOAT,0,((char*)NULL + (16*i)));
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		}
	}

	if(elementBufferName != 0)
	{
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, elementBufferName);
		glDrawElements(GL_QUADS,size*4,GL_UNSIGNED_INT, (char*)NULL);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
	}
	else
	{
		glDrawArrays(GL_QUADS,0,size*4);
	}

	if (texturecount > 0)
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		}

	if (colorBufferName != 0)
		glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
}

void EI_render_quad_buffer(float * vertexarray, float * texcoordsarray,int texturecount,float * colorarray,int size)
{

	GLuint bufname[3];
	bufname[0]= 0;
	bufname[1]= 0;
	bufname[2]= 0;
	glGenBuffers(3,bufname);

	glBindBuffer(GL_ARRAY_BUFFER,bufname[0]);
	glBufferData(GL_ARRAY_BUFFER,size*4*3*sizeof(float),vertexarray,GL_DYNAMIC_DRAW);
	glVertexPointer(3,GL_FLOAT,0,0);

	glBindBuffer(GL_ARRAY_BUFFER,bufname[1]);
	glBufferData(GL_ARRAY_BUFFER,size*4*3*sizeof(float),colorarray,GL_DYNAMIC_DRAW);
	glColorPointer(3,GL_FLOAT,0,(char*)NULL);
	glEnableClientState(GL_COLOR_ARRAY);

	if (texturecount > 0){
		glBindBuffer(GL_ARRAY_BUFFER,bufname[2]);
		glBufferData(GL_ARRAY_BUFFER,size*2*4*texturecount*sizeof(float),texcoordsarray,GL_DYNAMIC_DRAW);
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);

			//glTexCoordPointer(2,GL_FLOAT,0,(char*)NULL + 1*size*2*4*sizeof(float));
			glTexCoordPointer(2,GL_FLOAT,0,((char*)NULL + (16*i)));
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		}
	}

	glEnableClientState(GL_VERTEX_ARRAY);

	glDrawArrays(GL_QUADS,0,size<<2);
	//glDrawArrays(GL_QUADS,0,size);

	if (texturecount > 0)
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		}

	glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
	glDeleteBuffers(3, bufname);
}

void EI_render_quad_buffer_with_cubemap(float * vertexarray, float * texcoordsarray,float * texcubemap,int texturecount,int size)
{

	GLuint bufname[3];
	bufname[0]= 0;
	bufname[3]= 0;
    glGenBuffers(3,bufname);

    glBindBuffer(GL_ARRAY_BUFFER,bufname[0]);
 glBufferData(GL_ARRAY_BUFFER,size*4*3*sizeof(float),vertexarray,GL_DYNAMIC_DRAW);
    glVertexPointer(3,GL_FLOAT,0,0);


    glBindBuffer(GL_ARRAY_BUFFER,bufname[1]);
   glBufferData(GL_ARRAY_BUFFER,size*4*3*sizeof(float),texcubemap,GL_DYNAMIC_DRAW);
		glClientActiveTexture(GL_TEXTURE0);

   glTexCoordPointer(3,GL_FLOAT,0,(char*)NULL);

glEnableClientState(GL_TEXTURE_COORD_ARRAY);

    if (texturecount > 0)
    {

	glBindBuffer(GL_ARRAY_BUFFER,bufname[2]);
	glBufferData(GL_ARRAY_BUFFER,size*2*4*texturecount*sizeof(float),texcoordsarray,GL_DYNAMIC_DRAW);
	for (int i = 0; i < texturecount;i++)
	{
		glClientActiveTexture(GL_TEXTURE0 + i + 1);
		glTexCoordPointer(2,GL_FLOAT,0,((char*)NULL + (16*i)));
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	}

    }

   glEnableClientState(GL_VERTEX_ARRAY);



    glDrawArrays(GL_QUADS,0,size<<2);

if (texturecount > 0)
    for (int i = 0; i < texturecount;i++)
    {
	glClientActiveTexture(GL_TEXTURE0+i + 1);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    }
    glDisableClientState(GL_VERTEX_ARRAY);
    glDeleteBuffers(3, bufname);
}


void EI_render_quad_buffer_with_shader(float * vertexarray, float * texcoordsarray, float * colorarray,int texturecount,
					int size,unsigned int vertexProgramId,unsigned int fragmentProgramId)
{
//	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE,GL_ONE);
	glDepthMask(GL_FALSE);

	// on active les vertex/fragment program
	glEnable(GL_VERTEX_PROGRAM_ARB);
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB,vertexProgramId);
	glEnable(GL_FRAGMENT_PROGRAM_ARB);
	glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB,fragmentProgramId);

	GLuint bufname[3];
	bufname[0]= 0;
	bufname[1]= 0;
	bufname[2]= 0;
	glGenBuffers(3,bufname);

	glBindBuffer(GL_ARRAY_BUFFER,bufname[0]);
	glBufferData(GL_ARRAY_BUFFER,size*4*3*sizeof(float),vertexarray,GL_DYNAMIC_DRAW);
	glVertexPointer(3,GL_FLOAT,0,(char*)NULL);
 	glEnableClientState(GL_VERTEX_ARRAY);


	glBindBuffer(GL_ARRAY_BUFFER,bufname[1]);
	glBufferData(GL_ARRAY_BUFFER,size*4*3*sizeof(float),colorarray,GL_DYNAMIC_DRAW);
	glColorPointer(3,GL_FLOAT,0,(char*)NULL);
	glEnableClientState(GL_COLOR_ARRAY);

	if (texturecount > 0)
	{
		glBindBuffer(GL_ARRAY_BUFFER,bufname[2]);
		glBufferData(GL_ARRAY_BUFFER,size*4*4*texturecount*sizeof(float),texcoordsarray,GL_DYNAMIC_DRAW);
		for (int i = 0; i < texturecount;i++)
		{
			glClientActiveTexture(GL_TEXTURE0+i);
			//glTexCoordPointer(2,GL_FLOAT,0,(char*)NULL + 1*size*2*4*sizeof(float));

			//glTexCoordPointer(4,GL_FLOAT,0,((char*)NULL + (4*sizeof(float)*i)));
			glTexCoordPointer(4,GL_FLOAT,0,((char*)NULL + (64*i)));
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		}
	}



	glDrawArrays(GL_QUADS,0,size<<2);


	if (texturecount > 0)
	for (int i = 0; i < texturecount;i++)
	{
		glClientActiveTexture(GL_TEXTURE0+i);
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	}

	glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);

	glDeleteBuffers(3, bufname);


	glDisable(GL_FRAGMENT_PROGRAM_ARB);
	// on desactive les vertex/fragment program
	glDisable(GL_VERTEX_PROGRAM_ARB);

//	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_TRUE);
}




static void setup_opengl( int width, int height )
{
/*
    const unsigned char *exts = glGetString(GL_EXTENSIONS);

    glGenBuffers = (PFNGLGENBUFFERSARBPROC)SDL_GL_GetProcAddress("glGenBuffersARB");
    if (glGenBuffers == NULL)
    {
	    printf("Error loading glGenBuffersARB\n");
    }
    glBindBuffer = (PFNGLBINDBUFFERARBPROC)SDL_GL_GetProcAddress("glBindBufferARB");
    if (glBindBuffer == NULL)
    {
	    printf("Error loading glBindBufferARB\n");
    }
    glBufferData = (PFNGLBUFFERDATAARBPROC)SDL_GL_GetProcAddress("glBufferDataARB");
    if (glBufferData == NULL)
    {
	    printf("Error loading glBufferDataARB\n");
    }

    glDeleteBuffers = (PFNGLDELETEBUFFERSARBPROC)SDL_GL_GetProcAddress("glDeleteBuffersARB");
    if (glDeleteBuffers == NULL)
    {
	    printf("Error loading glDeleteBuffersARB\n");
    }

    glGenProgramsARB = (PFNGLGENPROGRAMSARBPROC)SDL_GL_GetProcAddress("glGenProgramsARB");
    if (glGenProgramsARB == NULL)
    {
	    printf("Error loading glGenProgramsARB\n");
    }
    glBindProgramARB = (PFNGLBINDPROGRAMARBPROC)SDL_GL_GetProcAddress("glBindProgramARB");
    if (glBindProgramARB == NULL)
    {
	    printf("Error loading glBindProgramARB\n");
    }

    glProgramStringARB = (PFNGLPROGRAMSTRINGARBPROC)SDL_GL_GetProcAddress("glProgramStringARB");
    if (glProgramStringARB == NULL)
    {
	    printf("Error loading glProgramStringARB\n");
    }
*/

    float ratio = (float) width / (float) height;

    /* Our shading model--Gouraud (smooth). */
    glShadeModel( GL_SMOOTH );
    //glShadeModel( GL_FLAT );

    /* Culling. */
    glCullFace( GL_BACK );
   // glFrontFace( GL_CCW );
    glEnable( GL_CULL_FACE );

    /* Z-Buffer */
    glEnable(GL_DEPTH_TEST);

    /* Texture 2d */
    glEnable(GL_TEXTURE_2D);


	glClearStencil(128);
    //glDisable(GL_TEXTURE_2D);
    //glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);

/*
    GLfloat ambientProperties[] = {1.f, 1.f, 1.f, 1.f};
    GLfloat positionProperties[] = {0.f, 10.f, 10.0f, 1.f};

                          //diffrents paramtres
   GLfloat ambient[] = {0.8f,0.8f,0.8f,1.0f};
   //GLfloat ambient[] = {0.5f,0.5f,0.5f,1.0f};
   GLfloat diffuse[] = {0.005f,0.005f,0.005f,1.0f};
   GLfloat light0_position [] = {0.0f, 10.0f, 10.0f, 10.f};
   GLfloat specular_reflexion[] = {0.8f,0.8f,0.8f,1.0f};
   GLubyte shiny_obj = 0;

   glLightfv(GL_LIGHT1,GL_AMBIENT,ambient);
   glLightfv(GL_LIGHT1,GL_DIFFUSE,diffuse);
   glLightfv(GL_LIGHT1,GL_POSITION,light0_position);



    glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
    glLightfv( GL_LIGHT0, GL_POSITION, positionProperties);

   //glEnable(GL_LIGHT0);
   // glEnable(GL_LIGHTING);


  // glEnable(GL_LIGHTING) ;                 // Active la gestion des lumires
 //  glEnable(GL_LIGHT0) ;                      // allume la lampe 0
 //  glEnable(GL_LIGHT1);

   //spcification de la rflexion sur les matriaux
 //  glEnable(GL_COLOR_MATERIAL);
   glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
   glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,ambient);
   glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diffuse);
   glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,specular_reflexion);
   glMateriali(GL_FRONT_AND_BACK,GL_SHININESS,shiny_obj);

*/

    /* Set the clear color. */
   // glClearColor( 1., 1., 1., 1. );

    /* Setup our viewport. */
    glViewport( 0, 0, width, height );

    /*
     * Change to the projection matrix and set
     * our viewing volume.
     */
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity( );
    /*
     * EXERCISE:
     * Replace this with a call to glFrustum.
     */
    gluPerspective( 60.0, ratio, 0.01, 600.0 );
	//glClearColor(0.0,0.0,0.5,0.0);

   //glEnable(GL_FOG);
   glDepthFunc(GL_LEQUAL);
}

void EI_prerender(void){


  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity( );

 // static float v3f[3] = {0.,0.,10.};
 //  glLightfv(GL_LIGHT0,GL_POSITION,v3f);

//glScalef(10.0,10.0,10.0);
glScalef(0.01,0.01,0.01);
	glColor3f(1.,1.,1.);
  //glRotatef(90.,0,0,-1.0);
	glDepthMask(GL_TRUE);

}

void EI_testrender(void){

  //glColor3f(1.,1.,1.);


  EI_setcolor(1.,1.,1.);
  glBegin(GL_TRIANGLES);
  glVertex3f(0.,5.,-5.);
  glVertex3f(-2.,5.,-5.);
  glVertex3f(-1,2.,-5.);
  glEnd();

/*
  EI_setcolor(0.,0.,0.);
  glBegin(GL_TRIANGLES);
  glVertex3f(1,1,5.);
  glVertex3f(-1.,1.,5.);
  glVertex3f(0.,1.,5.);
*/

  //glEnd();

}

void EI_frontquad(void)
{
	EI_set_inactive_texture(0);
	EI_set_inactive_texture(1);
	//glColor3f(1.0, 1.0, 1.0);
	//glDisable(GL_TEXTURE_2D);
	//affiche un carr noir transparent (couleur de l'ombre) partout sur l'cran :

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(0.0, 0.0, 0.0,0.3);
	//glMatrixMode(GL_PROJECTION);
	//glPushMatrix();
	//	glLoadIdentity();
	//	glOrtho(0.0, 1.0, 1.0, 0.0, -1.0, 1.0);
	//	glMatrixMode(GL_MODELVIEW);
		//glPushMatrix();
			//glLoadIdentity();

			glBegin(GL_QUADS);

				glVertex3f(-5.0, -5.0,-5.);
				glVertex3f(5.0, -5.0,-5.);
				glVertex3f(5.0, -5.0,5.);
				glVertex3f(-5.0, -5.0,5.);
	/*
				glVertex3f(-5.0, -5.0,-5.);
				glVertex3f(-5.0, 5.0,-5.);
				glVertex3f(5.0, 5.0,-5.);
				glVertex3f(5.0, -5.0,-5.);
*/
			glEnd();

			//glMatrixMode(GL_PROJECTION);
		//glPopMatrix();
	//	glMatrixMode(GL_MODELVIEW);
	//glPopMatrix();
	//glColor3f(1.0, 1.0, 1.0);

	glDisable(GL_BLEND);

	EI_set_active_texture(0);
	EI_set_active_texture(1);
}


void EI_postrender(void){
  //glScalef(100.0,100.0,100.0);
#ifdef ARE_SDL
  SDL_GL_SwapBuffers( );
#endif
}

void EI_translate(float x, float y, float z){
  glTranslatef(x,y,z);
}

void EI_rotate(float a_x,float a_y,float a_z){
  glRotatef(a_x,1.,0,0);
  glRotatef(a_y,0,1.,0);
  glRotatef(a_z,0,0,1.0);
}

int EI_new_list(int i)
{
    int id = glGenLists(i);
    printf("id liste: %d",id);
    glNewList(id,GL_COMPILE);
    return id;
}

void EI_end_list(void){
  glEndList();
  puts("LIST RECORDED");
}

void EI_call_list(int id){
  glCallList(id);
}

void EI_push_matrix(void){
  glPushMatrix();
}

void EI_pop_matrix(void){
  glPopMatrix();
}

void EI_load_identitymatrix(void){
  glLoadIdentity();
}


void EI_gen_textures(int n,unsigned int * textures_names){
  glEnable(GL_TEXTURE_2D);
  *textures_names = 0;
  glGenTextures(n,(GLuint *)textures_names);
#ifdef OPENGLDEBUG
  if (*textures_names == 0)
  {
    printf("OpenGL Error\n");
  } else printf("EI_gen_textures %d\n",textures_names);
    printf("EI_gen_textures:");
    switch (glGetError())
    {
      case GL_INVALID_ENUM : printf("GL_INVALID_ENUM\n");break;
      case GL_INVALID_VALUE : printf("GL_INVALID_VALUE\n");break;
      case GL_INVALID_OPERATION : printf("GL_INVALID_OPERATION\n");break;
      case GL_NO_ERROR : printf("GL_NO_ERROR\n");break;
      case GL_STACK_OVERFLOW : printf("GL_STACK_OVERFLOW\n");break;
      case GL_STACK_UNDERFLOW : printf("GL_STACK_UNDERFLOW\n");break;
      case GL_OUT_OF_MEMORY: printf("GL_OUT_OF_MEMORY\n");break;
    }
#endif

}
void EI_bind_2D_texture(unsigned int texture_name)
{
  //glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_BLEND);
/*
#ifdef OPENGLDEBUG
    printf("EI_bind_2D_texture 1st:");
    switch (glGetError())
    {
      case GL_INVALID_ENUM : printf("GL_INVALID_ENUM\n");break;
      case GL_INVALID_VALUE : printf("GL_INVALID_VALUE\n");break;
      case GL_INVALID_OPERATION : printf("GL_INVALID_OPERATION\n");break;
      case GL_NO_ERROR : printf("GL_NO_ERROR\n");break;
      case GL_STACK_OVERFLOW : printf("GL_STACK_OVERFLOW\n");break;
      case GL_STACK_UNDERFLOW : printf("GL_STACK_UNDERFLOW\n");break;
      case GL_OUT_OF_MEMORY: printf("GL_OUT_OF_MEMORY\n");break;
    }
#endif
*/
//glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,texture_name);
#ifdef OPENGLDEBUG
    printf("EI_bind_2D_texture:");
    switch (glGetError())
    {
      case GL_INVALID_ENUM : printf("GL_INVALID_ENUM\n");break;
      case GL_INVALID_VALUE : printf("GL_INVALID_VALUE\n");break;
      case GL_INVALID_OPERATION : printf("GL_INVALID_OPERATION\n");break;
      case GL_NO_ERROR : printf("GL_NO_ERROR\n");break;
      case GL_STACK_OVERFLOW : printf("GL_STACK_OVERFLOW\n");break;
      case GL_STACK_UNDERFLOW : printf("GL_STACK_UNDERFLOW\n");break;
      case GL_OUT_OF_MEMORY: printf("GL_OUT_OF_MEMORY\n");break;
    }
#endif

}
void EI_tex_image2d24(unsigned char * pixels,int w,int h,int texture_name){
 //glBindTexture(GL_TEXTURE_2D,texture_name);

 #ifdef OPENGLDEBUG
           //printf("Error: %d\n",glGetError());
    printf("EI_tex_image2d24 1st:");
    switch (glGetError())
    {
      case GL_INVALID_ENUM : printf("GL_INVALID_ENUM\n");break;
      case GL_INVALID_VALUE : printf("GL_INVALID_VALUE\n");break;
      case GL_INVALID_OPERATION : printf("GL_INVALID_OPERATION\n");break;
      case GL_NO_ERROR : printf("GL_NO_ERROR\n");break;
      case GL_STACK_OVERFLOW : printf("GL_STACK_OVERFLOW\n");break;
      case GL_STACK_UNDERFLOW : printf("GL_STACK_UNDERFLOW\n");break;
      case GL_OUT_OF_MEMORY: printf("GL_OUT_OF_MEMORY\n");break;
    }
#endif



    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_NEAREST);

 #ifdef OPENGLDEBUG
           //printf("Error: %d\n",glGetError());
    printf("EI_tex_image2d24 2nd:");
    switch (glGetError())
    {
      case GL_INVALID_ENUM : printf("GL_INVALID_ENUM\n");break;
      case GL_INVALID_VALUE : printf("GL_INVALID_VALUE\n");break;
      case GL_INVALID_OPERATION : printf("GL_INVALID_OPERATION\n");break;
      case GL_NO_ERROR : printf("GL_NO_ERROR\n");break;
      case GL_STACK_OVERFLOW : printf("GL_STACK_OVERFLOW\n");break;
      case GL_STACK_UNDERFLOW : printf("GL_STACK_UNDERFLOW\n");break;
      case GL_OUT_OF_MEMORY: printf("GL_OUT_OF_MEMORY\n");break;
    }
#endif
	//glTexImage2D(GL_TEXTURE_2D, 0, 4,w,h, 0, GL_RGB, GL_UNSIGNED_BYTE, (GLvoid *)pixels);

   //glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,w,h, 0, GL_RGB, GL_UNSIGNED_BYTE, (GLvoid *)pixels);

   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,w,h, 0, GL_BGR, GL_UNSIGNED_BYTE, (GLvoid *)pixels);
 #ifdef OPENGLDEBUG
           //printf("Error: %d\n",glGetError());
    printf("EI_tex_image2d24:");
    switch (glGetError())
    {
      case GL_INVALID_ENUM : printf("GL_INVALID_ENUM\n");break;
      case GL_INVALID_VALUE : printf("GL_INVALID_VALUE\n");break;
      case GL_INVALID_OPERATION : printf("GL_INVALID_OPERATION\n");break;
      case GL_NO_ERROR : printf("GL_NO_ERROR\n");break;
      case GL_STACK_OVERFLOW : printf("GL_STACK_OVERFLOW\n");break;
      case GL_STACK_UNDERFLOW : printf("GL_STACK_UNDERFLOW\n");break;
      case GL_OUT_OF_MEMORY: printf("GL_OUT_OF_MEMORY\n");break;
    }
#endif
}

void EI_tex_image2d32(unsigned char * pixels,int w,int h,int texture_name){
 //glBindTexture(GL_TEXTURE_2D,texture_name);

    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA,w,h, 0, GL_BGRA, GL_UNSIGNED_BYTE, (GLvoid *)pixels);
	//glTexImage2D(GL_TEXTURE_2D, 0, 3,w,h, 0, GL_RGB, GL_UNSIGNED_BYTE, (GLvoid *)pixels);
#ifdef OPENGLDEBUG
    printf("EI_tex_image2d32:");
    switch (glGetError())
    {
      case GL_INVALID_ENUM : printf("GL_INVALID_ENUM\n");break;
      case GL_INVALID_VALUE : printf("GL_INVALID_VALUE\n");break;
      case GL_INVALID_OPERATION : printf("GL_INVALID_OPERATION\n");break;
      case GL_NO_ERROR : printf("GL_NO_ERROR\n");break;
      case GL_STACK_OVERFLOW : printf("GL_STACK_OVERFLOW\n");break;
      case GL_STACK_UNDERFLOW : printf("GL_STACK_UNDERFLOW\n");break;
      case GL_OUT_OF_MEMORY: printf("GL_OUT_OF_MEMORY\n");break;
    }
#endif
}

void EI_texcoord_i(int x,int y)
{
    glTexCoord2i(x,y);
}

void EI_texcoord_f(float fX,float fY)
{
    //glTexCoord2f(fX,fY);
    glMultiTexCoord2f(GL_TEXTURE0,fX,fY);
}


int EI_getticks(void){
#ifdef ARE_SDL
    return SDL_GetTicks();
#else
	static int ticks = 0;
	ticks += 33*20;
	return ticks;
#endif
}

void EI_delay(int iDuration)
{
#ifdef ARE_SDL
  SDL_Delay(iDuration);
#endif
}

void EI_enable_textureblending(void)
{
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE,GL_ONE);
	//glBlendFunc(GL_DST_COLOR,GL_SRC_COLOR);
	//glBlendFunc(GL_DST_COLOR,GL_ZERO);
}
void EI_disable_textureblending(void)
{
  glDisable(GL_BLEND);
}


void EI_enable_blending(void)
{
  glEnable(GL_BLEND);
  //glBlendFunc(GL_ONE,GL_ONE);
  //glBlendFunc(GL_DST_COLOR,GL_ZERO);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glDisable(GL_DEPTH_TEST);
}

void EI_disable_blending(void)
{
  glDisable(GL_BLEND);
  glEnable(GL_DEPTH_TEST);
}

void EI_enable_depthtest(void)
{
  glEnable(GL_DEPTH_TEST);
}

void EI_disable_depthtest(void)
{
  glDisable(GL_DEPTH_TEST);
}

void EI_shadow_volume_step1(void)
{
	glDepthMask(GL_FALSE);
	glClear(GL_STENCIL_BUFFER_BIT);
	glColorMask(0,0,0,0);

	glEnable(GL_STENCIL_TEST);

	//glDisable(GL_DEPTH_TEST);
 //glStencilFunc(GL_ALWAYS,128,0xffffffff);

	glStencilFunc(GL_ALWAYS, 128, ~0);

	//glCopyPixels(0,0,8,8,GL_STENCIL);
  //printf("Error %d\n",glGetError());
	//if (GL_INVALID_OPERATION ==glGetError())
	//	puts("Invalid Operation");

}

void EI_shadow_volume_step2(void)
{
 // glFrontFace(GL_CW);
	glCullFace(GL_BACK);

//	glCullFace(GL_FRONT);
	//glCullFace(GL_BACK);
	//glDisable(GL_DEPTH_TEST);
  glStencilOp(GL_KEEP,GL_KEEP,GL_INCR);
}

void EI_shadow_volume_step3(void)
{
  //glEnable(GL_DEPTH_TEST);
	glCullFace(GL_FRONT);

	//glCullFace(GL_BACK);
  //glFrontFace(GL_CCW);

	glStencilOp(GL_KEEP,GL_KEEP,GL_DECR);
}

void EI_shadow_volume_step4(void)
{
  glColorMask(1,1,1,1);
//glStencilFunc(GL_NOTEQUAL,128,0xffffffff);
//	glStencilFunc(GL_ALWAYS,0,0xffffffff);
 glStencilFunc(GL_NOTEQUAL, 128, ~0);

	//glStencilFunc(GL_GREATER, 0, ~0);
  glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);

	//glDisable(GL_DEPTH_TEST);
  glCullFace(GL_BACK);

  //glFrontFace(GL_CW);
}

void EI_shadow_volume_step5(void)
{
 // glEnable(GL_DEPTH_TEST);
  glDepthMask(GL_TRUE);
  glDisable(GL_STENCIL_TEST);

}

void EI_setup_dot3(int normalMapId,unsigned int normalCubeMapId)
{
//	glDisable(GL_DEPTH_TEST);

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE,GL_ONE);
	glDepthMask(GL_FALSE);

	// on doit reconfigurer les unites de textures
	// la premiere unite contient la cube map de normalisation
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_CUBE_MAP_ARB);
	glBindTexture(GL_TEXTURE_CUBE_MAP_ARB, normalCubeMapId);
	// on souhaite que la cube map remplace la couleur des vertex
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);


	// on doit reconfigurer les unites de textures
	// la premiere unite contient la normal map
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glEnable(GL_TEXTURE_2D);

	glBindTexture(GL_TEXTURE_2D, normalMapId);

	// on configure la normal map pour qu'elle effectue la passe de DOT3

	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_COMBINE_ARB);

	glTexEnvf(GL_TEXTURE_ENV,GL_RGB_SCALE_ARB,1);

	glTexEnvf(GL_TEXTURE_ENV,GL_COMBINE_RGB_ARB,GL_DOT3_RGB_ARB);

	glTexEnvf(GL_TEXTURE_ENV,GL_SOURCE0_RGB_ARB,GL_PREVIOUS_ARB);
	glTexEnvf(GL_TEXTURE_ENV,GL_SOURCE1_RGB_ARB,GL_TEXTURE);
	glTexEnvf(GL_TEXTURE_ENV,GL_OPERAND0_RGB_ARB,GL_SRC_COLOR);
	glTexEnvf(GL_TEXTURE_ENV,GL_OPERAND1_RGB_ARB,GL_SRC_COLOR);

	//glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);

}

void EI_quit_dot3()
{
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	glDisable(GL_TEXTURE_CUBE_MAP_ARB);

	glActiveTextureARB(GL_TEXTURE1_ARB);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	glDisable(GL_TEXTURE_2D);

	glActiveTextureARB(GL_TEXTURE2_ARB);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	glDisable(GL_TEXTURE_2D);

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);

//	glEnable(GL_DEPTH_TEST);
}

void EI_setup_dot3_texture(int textureId)
{
	// on doit reconfigurer les unites de textures
	// la premiere unite contient la normal map
	//printf("tex 2:  %d",textureId);

	glActiveTextureARB(GL_TEXTURE2_ARB);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,textureId );
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);

}

void EI_draw_local_space(float * vertex, float * tangent, float * binormal, float * normal)
{

	EI_set_inactive_texture(0);
	EI_set_inactive_texture(1);
	glBegin(GL_LINES);

	// tangente en rouge
	glColor3f(1,0,0);
	glVertex3f(vertex[0],vertex[1],vertex[2]);
	glVertex3f(tangent[0]+vertex[0],tangent[1]+vertex[1],tangent[2]+vertex[2]);
	// binormale en vert
	glColor3f(0,1,0);
	glVertex3f(vertex[0],vertex[1],vertex[2]);
	glVertex3f(binormal[0]+vertex[0],binormal[1]+vertex[1],binormal[2]+vertex[2]);
	// normale en bleu
	glColor3f(0,0,1);
	glVertex3f(vertex[0],vertex[1],vertex[2]);
	glVertex3f(normal[0]+vertex[0],normal[1]+vertex[1],normal[2]+vertex[2]);

	glEnd();
	//EI_set_active_texture(0);
	//EI_set_active_texture(1);
}


void getCubeVector(int i, int cubesize, int x, int y, float *vector)
{
	float s, t, sc, tc, mag;

	s = ((float)x + 0.5) / (float)cubesize;
	t = ((float)y + 0.5) / (float)cubesize;
	sc = s*2.0 - 1.0;
	tc = t*2.0 - 1.0;

	// selon la face passee en parametre, on calcul le vecteur vers le centre de la cube map.
	switch (i)
	{
		case 0:
			vector[0] = 1.0;
			vector[1] = -tc;
			vector[2] = -sc;
			break;
		case 1:
			vector[0] = -1.0;
			vector[1] = -tc;
			vector[2] = sc;
			break;
		case 2:
			vector[0] = sc;
			vector[1] = 1.0;
			vector[2] = tc;
			break;
		case 3:
			vector[0] = sc;
			vector[1] = -1.0;
			vector[2] = -tc;
			break;
		case 4:
			vector[0] = sc;
			vector[1] = -tc;
			vector[2] = 1.0;
			break;
		case 5:
			vector[0] = -sc;
			vector[1] = -tc;
			vector[2] = -1.0;
			break;
	}
	// on normalise le vecteur.
	mag = 1.0/sqrt(vector[0]*vector[0] + vector[1]*vector[1] + vector[2]*vector[2]);
	vector[0] *= mag;
	vector[1] *= mag;
	vector[2] *= mag;
}

void EI_generate_normalisation_cubemap(int size,unsigned int * normalCubeMapId)
{

	glEnable(GL_TEXTURE_CUBE_MAP_ARB);
	//genere l'objet de texture OpenGL en memoire vido
	glGenTextures(1,normalCubeMapId);
	printf("texture id: %d\n",*normalCubeMapId);
	glBindTexture(GL_TEXTURE_CUBE_MAP_ARB, *normalCubeMapId);


	float vector[3];
	int i, x, y;
	GLubyte *pixels = new GLubyte[size*size*3];

	// on configure la texture. On utilise un filtrage lineaire pour ne pas avoir
	// generer les mipmaps.
	glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

	// Pour chaque face
	for (i = 0; i < 6; i++)
	{
		// on remplit le buffer de texture avec des vecteurs
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				getCubeVector(i, size, x, y, vector);
				pixels[3*(y*size+x) + 0] = (unsigned char)(128. - 127.*vector[0]);
				pixels[3*(y*size+x) + 1] = (unsigned char)(128. - 127.*vector[1]);
				pixels[3*(y*size+x) + 2] = (unsigned char)(128. - 127.*vector[2]);
			}
		}
		// on envoi le buffer de texture  OpenGL
		gluBuild2DMipmaps(GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB+i,GL_RGB8,size,size,GL_RGB,GL_UNSIGNED_BYTE,pixels);
	}

	delete [] pixels;

	glDisable(GL_TEXTURE_CUBE_MAP_ARB);
}

void EI_program_param_glsl(unsigned int programid,const char * varname,float * varvalue,int length)
{
	int id = glGetUniformLocationARB(programid, varname);
	if (length == 3)
		glUniform3fARB(id, varvalue[0], varvalue[1], varvalue[2]);
	if (length == 9)
		glUniformMatrix3fv(programid,1,0,varvalue);

}

void EI_load_program_glsl(const char * vsfilename,const char * psfilename,unsigned int * shaderProgramId)
{
	FILE * f;
	char * shaderProgram;
	const char * cshaderProgram;
	char log[10000];
	int lenlog;
	unsigned int len;
	unsigned int size;
	GLenum my_vertex_shader;
	GLenum my_pixel_shader;
	GLenum my_program;

	my_program = glCreateProgramObjectARB();

	if (vsfilename != NULL)
	{
		printf("Vertex shader %s\n",vsfilename);
		f = fopen(vsfilename,"r");
		if (f == NULL)
		{
			printf("Error loading vertex program file %s\n",vsfilename);
			return;
		}
		fseek(f,0,SEEK_END);
		size = ftell(f);
		fseek(f,0,SEEK_SET);
		shaderProgram = new char[size];
		len = fread(shaderProgram,sizeof(char),size,f);
		fclose(f);
		printf("vertex shader length: %d\n",len);
		shaderProgram[len] = 0;
		cshaderProgram = shaderProgram;

		my_vertex_shader = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
		glShaderSourceARB(my_vertex_shader, 1, &cshaderProgram, NULL);
		glCompileShader(my_vertex_shader);
		glGetInfoLogARB(my_vertex_shader, 10000, &lenlog, log);
		if (lenlog > 0)
		{
			printf("log compiling: %s %s\n",vsfilename,log);
		}

		glAttachObjectARB(my_program, my_vertex_shader);
		glGetInfoLogARB(my_pixel_shader, 10000, &lenlog, log);
		if (lenlog > 0)
		{
			printf("log attaching: %s %s\n",vsfilename,log);
		}


		glLinkProgramARB(my_program);
		glGetInfoLogARB(my_pixel_shader, 10000, &lenlog, log);
		if (lenlog > 0)
		{
			printf("log linking: %s %s\n",vsfilename,log);
		}

		delete shaderProgram;

	}

	if (psfilename != NULL)
	{
		printf("Pixel shader %s\n",psfilename);
		f = fopen(psfilename,"r");
		if (f == NULL)
		{
			printf("Error loading pixel program file %s\n",psfilename);
			return;
		}
		fseek(f,0,SEEK_END);
		size = ftell(f);
		fseek(f,0,SEEK_SET);
		shaderProgram = new char[size];
		len = fread(shaderProgram,sizeof(char),size,f);
		fclose(f);

		printf("pixel shader length: %d\n",len);
		shaderProgram[len] = 0;
		cshaderProgram = shaderProgram;

		my_pixel_shader = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);
		glShaderSourceARB(my_pixel_shader, 1, &cshaderProgram, NULL);
		glCompileShader(my_pixel_shader);
		glGetInfoLogARB(my_pixel_shader, 10000, &lenlog, log);
		printf("log compiling: %s %s\n",psfilename,log);

		glAttachObjectARB(my_program, my_pixel_shader);
		glGetInfoLogARB(my_pixel_shader, 10000, &lenlog, log);
		printf("log attaching: %s %s\n",psfilename,log);

		glLinkProgramARB(my_program);
		glGetInfoLogARB(my_pixel_shader, 10000, &lenlog, log);
		printf("log linking: %s %s\n",psfilename,log);

		delete shaderProgram;

		printf("Shader prog %d\n",my_program);
	}
	*shaderProgramId =(unsigned int)my_program;
}

void EI_use_program_glsl(unsigned int shaderProgramId)
{
	//printf("EI_use_program_glsl %d\n",shaderProgramId);
	glUseProgramObjectARB((GLenum)shaderProgramId);
}


void EI_load_vertex_program(const char * filename,unsigned int * vertexProgramId)
{
	FILE * f;
	char vertexProgram[10480];
	unsigned int len;
	f = fopen(filename,"r");
	if (f == NULL)
	{
		printf("Error loading vertex program file %s",filename);
		return;
	}


	len = fread(vertexProgram,sizeof(char),10480,f);

	fclose(f);

	vertexProgram[len] = 0;
	// chargement du vertex program
	glGenProgramsARB(1, vertexProgramId);

		//printf("kikoo\n");
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB, *vertexProgramId);
	glProgramStringARB(GL_VERTEX_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB,
				strlen((char*) vertexProgram), vertexProgram);

	if(GL_INVALID_OPERATION == glGetError())
	{
		//une erreur est detectee
		//recupere les informations sur l'erreur survenue
		const unsigned char* errorString;
		GLint errorPos = 0;
		errorString=glGetString(GL_PROGRAM_ERROR_STRING_ARB);
		glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB,&errorPos);

		fprintf(stderr,"une erreur est survenue a la position : %d\n%s\n",
				 errorPos, errorString);
		// on affiche le program jusqu'a l'erreur
		for (int i = 0; i < errorPos; i++)
		{
			printf("%c", vertexProgram[i]);
		}
		printf("\n");
	}
}


void EI_load_fragment_program(const char * filename,unsigned int * fragmentProgramId)
{
	FILE * f;
	char fragmentProgram[10480];
	unsigned int len;
	f = fopen(filename,"r");
	if (f == NULL)
	{
		puts("Error loading vertex program file");
		return;
	}

	len = fread(fragmentProgram,sizeof(char),10480,f);

	fclose(f);

	fragmentProgram[len] = 0;
	// chargement du vertex program
	glGenProgramsARB(1,fragmentProgramId);
	glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB, *fragmentProgramId);
	glProgramStringARB(GL_FRAGMENT_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB,
				strlen((char*) fragmentProgram), fragmentProgram);

	if(GL_INVALID_OPERATION == glGetError())
	{
		//une erreur est detectee
		//recupere les informations sur l'erreur survenue
		const unsigned char* errorString;
		GLint errorPos = 0;
		errorString=glGetString(GL_PROGRAM_ERROR_STRING_ARB);
		glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB,&errorPos);

		fprintf(stderr,"une erreur est survenue a la position : %d\n%s\n",
				 errorPos, errorString);
		// on affiche le program jusqu'a l'erreur
		for (int i = 0; i < errorPos; i++)
		{
			printf("%c", fragmentProgram[i]);
		}
		printf("\n");
	}
}


void EI_set_fog(float density, float r, float g, float b)
{
	GLfloat dens = density;
	GLfloat fogColor[4] = {r, g, b, 1.0};
	glFogi (GL_FOG_MODE, GL_EXP2);
	glFogfv (GL_FOG_COLOR, fogColor);
	glFogf (GL_FOG_DENSITY, density);
	glHint (GL_FOG_HINT, GL_NICEST);
}

void EI_enable_fog(void)
{
	glEnable (GL_FOG);
}

void EI_disable_fog(void)
{
	glDisable (GL_FOG);
}

