#include "face.h"
#include "vector3f.h"

void FaceGroupAddFaceIndexItem(FaceGroup * fgrp,int size,int * faceindex)
{
	for (int i = 0;i < size;i++)
		fgrp->pFaceIndexBuffer[fgrp->uFaceIndexBufferOffset+i].i = faceindex[i];
	fgrp->uFaceIndexBufferOffset += size;
}

void FaceGroupAddVertexItem(FaceGroup * fgrp,int size,float * vertex)
{
	for (int i = 0;i < size;i++)
		fgrp->pVertBuffer[fgrp->uVertBufferOffset+i].f = vertex[i];
	fgrp->uFaceIndexBufferOffset += size;	
}

void FaceGroupAddTriangle(FaceGroup * facegrp,float * a,float * b,float *c)
{
	//printf("AddTriangle i:%d %d %f:%f:%f - %f:%f:%f - %f:%f:%f\n",facegrp->faceCount,facegrp->verticesCount,a[0],a[1],a[2],b[0],b[1],b[2],c[0],c[1],c[2]);
	facegrp->pFaceIndexBuffer[facegrp->faceCount*3].i = facegrp->verticesCount;


	facegrp->pVertBuffer[facegrp->verticesCount*3].f = a[0];
	facegrp->pVertBuffer[facegrp->verticesCount*3+1].f = a[1];
	facegrp->pVertBuffer[facegrp->verticesCount*3+2].f = a[2];	
	facegrp->verticesCount++;	
	
	facegrp->pFaceIndexBuffer[facegrp->faceCount*3+1].i = facegrp->verticesCount;

	
	facegrp->pVertBuffer[facegrp->verticesCount*3].f = b[0];
	facegrp->pVertBuffer[facegrp->verticesCount*3+1].f = b[1];
	facegrp->pVertBuffer[facegrp->verticesCount*3+2].f = b[2];
	facegrp->verticesCount++;
	
	facegrp->pFaceIndexBuffer[facegrp->faceCount*3+2].i = facegrp->verticesCount;

		
	facegrp->pVertBuffer[facegrp->verticesCount*3].f = c[0];
	facegrp->pVertBuffer[facegrp->verticesCount*3+1].f = c[1];
	facegrp->pVertBuffer[facegrp->verticesCount*3+2].f = c[2];		
	facegrp->verticesCount++;	
	facegrp->faceCount++;			
	//printf("end\n");
	
	
}


void computeNormal(face * pface, float ** vertexbuffer)
{
	vector3f res;
	vector3f vm1;
	vector3f vm2;
	vector3f v0 = vector3f(vertexbuffer[pface->vertexindex[0]]);
	vector3f v1 = vector3f(vertexbuffer[pface->vertexindex[1]]);
	vector3f v2 = vector3f(vertexbuffer[pface->vertexindex[2]]);       
	vector3f::sub(vm1,v1,v0);
	vector3f::sub(vm2,v2,v0);
	vector3f::vect(res,vm1,vm2);
	res.normalize();
	res.print();
	pface->normal[0] = res(0);       
	pface->normal[1] = res(1);       
	pface->normal[2] = res(2);   	
}

void computeLocalSpace(face * pface, float **vertexbuffer, float **normalbuffer,float **binormalbuffer, float **tangentbuffer)
{
		vector3f res;
		vector3f vm1;
		vector3f vm2;
		vector3f v0 = vector3f(vertexbuffer[pface->vertexindex[0]]);
		vector3f v1 = vector3f(vertexbuffer[pface->vertexindex[1]]);
		vector3f v2 = vector3f(vertexbuffer[pface->vertexindex[2]]);       
		vector3f::sub(vm1,v1,v0);
		vector3f::sub(vm2,v2,v0);
		vector3f::vect(res,vm1,vm2);
		res.normalize();
		//res.print();
		pface->normal[0] = res(0);       
		pface->normal[1] = res(1);       
		pface->normal[2] = res(2);   		

	if (pface->nbvertices == 4)
	{
		face * ptriangleface = new face;
		
		for (int i = 0;i < 6;i++)
		{
			ptriangleface->texCoords[i] = pface->texCoords[i];
		}
		ptriangleface->nbvertices = 3;
		
		ptriangleface->vertexindex[0]= pface->vertexindex[0];
		ptriangleface->vertexindex[1]= pface->vertexindex[1];
		ptriangleface->vertexindex[2]= pface->vertexindex[2];		
		computeLocalSpace(ptriangleface,vertexbuffer,normalbuffer,binormalbuffer,tangentbuffer);
		
		
		ptriangleface->texCoords[0] = pface->texCoords[0];		
		ptriangleface->texCoords[1] = pface->texCoords[1];		
		
		ptriangleface->texCoords[2] = pface->texCoords[4];		
		ptriangleface->texCoords[3] = pface->texCoords[5];			
		
		ptriangleface->texCoords[4] = pface->texCoords[6];		
		ptriangleface->texCoords[5] = pface->texCoords[7];	

		ptriangleface->texCoords[0] = pface->texCoords[6];		
		ptriangleface->texCoords[1] = pface->texCoords[7];		
		
		ptriangleface->texCoords[2] = pface->texCoords[0];		
		ptriangleface->texCoords[3] = pface->texCoords[1];			
		
		ptriangleface->texCoords[4] = pface->texCoords[4];		
		ptriangleface->texCoords[5] = pface->texCoords[5];	
		
	
		for (int i = 0;i < 3;i++)
		{
			printf("%f %f\n",ptriangleface->texCoords[i* 2],ptriangleface->texCoords[i*2 + 1]);
		}		
		
		/*
		for (int i = 0;i < 6;i++)
		{
			ptriangleface->texCoords[i] = pface->texCoords[i];
		}
		ptriangleface->nbvertices = 3;
		*/
		ptriangleface->vertexindex[0]= pface->vertexindex[0];
		ptriangleface->vertexindex[1]= pface->vertexindex[2];
		ptriangleface->vertexindex[2]= pface->vertexindex[3];		
		computeLocalSpace(ptriangleface,vertexbuffer,normalbuffer,binormalbuffer,tangentbuffer);

		delete ptriangleface;
		
	} else 
	{

			
		
		
		
		// maintenant on calcule les coefficients des tangentes
		// ces coefficients sont calcules en fonction des 
		// coordonnes de textures du polygone
		float deltaT0 = pface->texCoords[3] - pface->texCoords[1];
		float deltaT1 = pface->texCoords[5] - pface->texCoords[1];
		// on effectue la meme chose pour la binormale
		float deltaB0 = pface->texCoords[2] - pface->texCoords[0];
		float deltaB1 = pface->texCoords[4] - pface->texCoords[0];
		// le facteur permettant de rendre les tangentes et binormales
		// proportionnelles aux coordonnees de textures.
		// nous aurons donc des vecteurs dont la norme depend des coordonnees 
		// de textures.
		float scale = 1/ ((deltaB0 * deltaT1) - (deltaB1 * deltaT0));	
		printf("D0= %f",deltaB0 * deltaT1);
		printf(" D1= %f\n",deltaB1 * deltaT0);		
		printf ("Scale: %f\n",scale);
		//scale = -1.;
	
		// on calcule la tangente temporaire
		vector3f tmpTangente = ((vm1*deltaT1) - (vm2*deltaT0))*scale;
		//tmpTangente.print();
		//puts("Normal");
		tmpTangente.normalize();
		tmpTangente.print();	
	
		//tmpTangente = vm1-vm2;
	
		/*
		vector3f tmp = vm1 - vm2;
		tmp.normalize();
		tmp.print();
		*/

	
		//puts("Tangente");
		//tmpTangente.print();

		// on calcule la binormale temporaire
		vector3f tmpBinormal = ((vm1*(-deltaB1)) + (vm2*deltaB0))*scale;
		//tmpBinormal.print();
		//puts("Normal");		
		tmpBinormal.normalize();	
		tmpBinormal.print();
	
		//tmpBinormal = vm2 - vm1;
	
		puts("--------");
		//puts("Binormale");
		//tmpBinormal.print();
	
		for (int i =0;i < pface->nbvertices;i++)
		{
			binormalbuffer[pface->vertexindex[i]][0] += tmpBinormal(0);
			binormalbuffer[pface->vertexindex[i]][1] += tmpBinormal(1);
			binormalbuffer[pface->vertexindex[i]][2] += tmpBinormal(2);	
		
			tangentbuffer[pface->vertexindex[i]][0] += tmpTangente(0);
			tangentbuffer[pface->vertexindex[i]][1] += tmpTangente(1);
			tangentbuffer[pface->vertexindex[i]][2] += tmpTangente(2);

			normalbuffer[pface->vertexindex[i]][0] += res(0);
			normalbuffer[pface->vertexindex[i]][1] += res(1);
			normalbuffer[pface->vertexindex[i]][2] += res(2);		
		}
	}

}

void computeLocalSpaceVertex(float *normalbuffer,float *binormalbuffer, float *tangentbuffer)
{
		vector3f normal = vector3f(normalbuffer);
		vector3f c1;
		vector3f::vect(c1,normal,vector3f(0.0,0.0,1.0));		
		vector3f c2; 
		vector3f::vect(c2,normal,vector3f(0.0,1.0,0.0));		

		vector3f tmpTangent;
		vector3f tmpBinormal;
		
		if (c1.length() > c2.length())
		{
			tmpTangent = c1;
		}
		else 
		{
			tmpTangent = c2;
		}
		puts("***");
		tmpTangent.normalize();
		tmpTangent.print();
		vector3f::vect(tmpBinormal,normal,tmpTangent);
		
		tmpBinormal.normalize();
		tmpBinormal.print();
		
		tmpTangent.copy_to(tangentbuffer);
		tmpBinormal.copy_to(binormalbuffer);
		
		printf("Vector %f %f %f\n",binormalbuffer[0],binormalbuffer[1],binormalbuffer[2]);
		puts("kikoo");
}


void computeLocalSpace2(face * pface, float **vertexbuffer, float **normalbuffer,float **binormalbuffer, float **tangentbuffer)
{
		vector3f res;
		vector3f vm1;
		vector3f vm2;
		vector3f v0 = vector3f(vertexbuffer[pface->vertexindex[0]]);
		vector3f v1 = vector3f(vertexbuffer[pface->vertexindex[1]]);
		vector3f v2 = vector3f(vertexbuffer[pface->vertexindex[2]]);   
		vm1 = v1 - v0;
		vm2 = v2 - v0;
		//vector3f::sub(vm1,v1,v0);
		//vector3f::sub(vm2,v2,v0);
		vector3f::vect(res,vm1,vm2);
		res.normalize();
		//printf("Face Normal: \n");
		//res.print();
		pface->normal[0] = res(0);       
		pface->normal[1] = res(1);       
		pface->normal[2] = res(2);   		

	if (pface->nbvertices == 4)
	{
		face * ptriangleface = new face;
		
		ptriangleface->nbvertices = 3;
		
		ptriangleface->vertexindex[0]= pface->vertexindex[0];
		ptriangleface->vertexindex[1]= pface->vertexindex[1];
		ptriangleface->vertexindex[2]= pface->vertexindex[2];		
		computeLocalSpace2(ptriangleface,vertexbuffer,normalbuffer,binormalbuffer,tangentbuffer);
					
		ptriangleface->vertexindex[0]= pface->vertexindex[0];
		ptriangleface->vertexindex[1]= pface->vertexindex[2];
		ptriangleface->vertexindex[2]= pface->vertexindex[3];		
		computeLocalSpace2(ptriangleface,vertexbuffer,normalbuffer,binormalbuffer,tangentbuffer);

		delete ptriangleface;
		
	} else 
	{
		/*
		vector3f res;
		vector3f vm1;
		vector3f vm2;
		vector3f v0 = vector3f(vertexbuffer[pface->vertexindex[0]]);
		vector3f v1 = vector3f(vertexbuffer[pface->vertexindex[1]]);
		vector3f v2 = vector3f(vertexbuffer[pface->vertexindex[2]]);       
		vector3f::sub(vm1,v1,v0);
		vector3f::sub(vm2,v2,v0);
		vector3f::vect(res,vm1,vm2);
		res.normalize();
		res.print();
		pface->normal[0] = res(0);       
		pface->normal[1] = res(1);       
		pface->normal[2] = res(2);   	
		*/
		
		vector3f c1;
		vector3f::vect(c1,res,vector3f(0.0,0.0,1.0));		
		vector3f c2; 
		vector3f::vect(c2,res,vector3f(0.0,1.0,0.0));		

		vector3f tmpTangent;
		vector3f tmpBinormal;
		
		if (c1.length() > c2.length())
		{
			tmpTangent = c1;
		}
		else 
		{
			tmpTangent = c2;
		}
		//puts("***");
		tmpTangent.normalize();
		//tmpTangent.print();
		vector3f::vect(tmpBinormal,res,tmpTangent);
		
		tmpBinormal.normalize();
		//tmpBinormal.print();
		
		//res.print();
		for (int i =0;i < pface->nbvertices;i++)
		{
			binormalbuffer[pface->vertexindex[i]][0] += tmpBinormal(0);
			binormalbuffer[pface->vertexindex[i]][1] += tmpBinormal(1);
			binormalbuffer[pface->vertexindex[i]][2] += tmpBinormal(2);	
		
			tangentbuffer[pface->vertexindex[i]][0] += tmpTangent(0);
			tangentbuffer[pface->vertexindex[i]][1] += tmpTangent(1);
			tangentbuffer[pface->vertexindex[i]][2] += tmpTangent(2);

			normalbuffer[pface->vertexindex[i]][0] += res(0);
			normalbuffer[pface->vertexindex[i]][1] += res(1);
			normalbuffer[pface->vertexindex[i]][2] += res(2);		
		}
	}

}

