
#include "image.h"
#include "image24.h"

//#include <SDL.h>
#include <SDL/SDL.h>



image24::image24(unsigned char * pixels,int w,int h) : image(w,h)

{

  this->pixels = pixels;

}

image24::image24(char * filename)

{

  SDL_Surface * surface = SDL_LoadBMP(filename);
  printf("BitPerPixel: %d\n",surface->format->BitsPerPixel);
  this->w = surface->w;

  this->h = surface->h;

  this->pixels = new unsigned char[surface->w*surface->h*3];

  unsigned char * texels = (unsigned char*)surface->pixels;
/* Correct the wrong format BGR->RGB in bigendian processor*/
  for (int i = 0;i < surface->w*surface->h;i++)
{
/*
  this->pixels[i*3] = texels[i*3+2];
  this->pixels[i*3+1] = texels[i*3+1];
  this->pixels[i*3+2] = texels[i*3];
*/

  this->pixels[i*3] = texels[i*3];
  this->pixels[i*3+1] = texels[i*3+1];
  this->pixels[i*3+2] = texels[i*3+2];

}

}

image24::~image24()
{
  delete this->pixels;   
}

int image24::get_pixel(int x,int y)
{
  return this->pixels[x + y*w];
}

void image24::set_pixels(unsigned char * pixels)
{
  this->pixels = pixels;
}

unsigned char * image24::get_pixels(void)
{
  return this->pixels;

}
