
#include "image.h"
#include "image32.h"

//#include <SDL.h>
#include <SDL/SDL.h>

#include <stdio.h>

image32::image32(unsigned char * pixels,int w,int h) : image(w,h)

{

  this->pixels = pixels;

}

image32::image32(char * filename)

{
	SDL_Surface * surface = SDL_LoadBMP(filename);
	if (surface == NULL)
	{
		printf("Cannot Load BMP %s\n",filename);
	}
  
  this->w = surface->w;
  this->h = surface->h;
  this->pixels = new unsigned char[surface->w*surface->h*4];

  unsigned char * texels = (unsigned char*)surface->pixels;
/* Correct the wrong format BGR->RGB in bigendian processor*/

 for (int i = 0;i < surface->w*surface->h;i++)
{
/*
  this->pixels[i*4] = texels[i*4+2];
  this->pixels[i*4+1] = texels[i*4+1];
  this->pixels[i*4+2] = texels[i*4];
*/

/*
  this->pixels[i*4] = texels[i*4+2];
  this->pixels[i*4+1] = texels[i*4+1];
  this->pixels[i*4+2] = texels[i*4];
 */
  this->pixels[i*4] = texels[i*4];
  this->pixels[i*4+1] = texels[i*4+1];
  this->pixels[i*4+2] = texels[i*4+2]; 
  this->pixels[i*4+3] = 255;

/*
  this->pixels[i*4] = 128;
  this->pixels[i*4+1] = 128;
  this->pixels[i*4+2] = 128;
  this->pixels[i*4+3] = 128;
*/
}
   //set_coloralphavalue(0,0,0,0);
}

image32::~image32()
{
  delete this->pixels;   
}

int image32::get_pixel(int x,int y)
{
  return this->pixels[x + y*w];
}

void image32::set_pixels(unsigned char * pixels)
{
  this->pixels = pixels;
}

unsigned char * image32::get_pixels(void)
{
  return this->pixels;

}

void image32::set_coloralphavalue(int r, int g, int b, int a)
{
  for (int i = 0;i < this->w*this->h;i++)
  {

    if ((this->pixels[i*4] == r)&&(this->pixels[i*4+1] == g)&&(this->pixels[i*4+2]==b)){
      this->pixels[i*4+3] = a;
      }
  }
}

void image32::set_globalalphavalue(int a)
{
  for (int i = 0;i < this->w*this->h;i++)
  {
    this->pixels[i*4+3] = a;
  }
}


