#include "importer3ds.h"
#include "object.h"
#include "face.h"
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string.h>
using namespace std;

int EatChunk(char* buffer);
struct CVertex
{
    float x,y,z;
};

struct CUVMap
{
	float u,v;
};

struct CPolygon
{
    int verts[3];
};

struct CModel
{
    CVertex* verts;
    int numverts;
    CPolygon* polys;
    int numpolys;
    CUVMap * uvmaps;
    int numuvmaps;
    
};

CModel g_model;

void Model2Object(CModel * model,object * obj)
{

		bool mergevertex = false;
		
		for (int i = 0;i < model->numverts;i++)
		{
			float x = model->verts[i].x;
			float y = model->verts[i].y;
			float z = model->verts[i].z;
			for(int j = 0;j < model->numverts;j++)
			{
				if (x == model->verts[j].x)
				 if (y == model->verts[j].y)
					if (z == model->verts[j].z)
						if (i != j)
						{

							mergevertex = true;	
						}
						
			}				
		}	
		if (!mergevertex)
		{
			puts("DUPLICATE VERTEX FOUND MERGING...");			
			int countmerged = 0;		
			for (int i = 0;i < model->numpolys;i++)
			{
				for (int j = 0;j < 3;j++)
				{
					int index = model->polys[i].verts[j];
					for (int l = 0;l < index;l++)
					{
						if (model->verts[index].x == model->verts[l].x)
							if (model->verts[index].y == model->verts[l].y)
								if (model->verts[index].z == model->verts[l].z)		
								{
									model->polys[i].verts[j] = l;
									countmerged++;
									break;
								}											
					}
				}
			}
			printf("VERTEX MERGED: %d\n",countmerged);
		}
			
		obj->vertexcount = model->numverts;
		obj->vertices = new float*[obj->vertexcount];
		
		for (int i = 0;i < obj->vertexcount;i++)
		{
			obj->vertices[i] = new float[3];
			
			obj->vertices[i][0] = model->verts[i].x * 0.02;
			obj->vertices[i][1] = model->verts[i].y * 0.02;
			obj->vertices[i][2] = model->verts[i].z * 0.02;
			
			/*
			
			obj->vertices[i][0] = model->verts[i].x * 1.;
			obj->vertices[i][1] = model->verts[i].y * 1.;
			obj->vertices[i][2] = model->verts[i].z * 1.;
			*/			
			//printf("vertice: %f %f %f\n",obj->vertices[i][0],obj->vertices[i][1],obj->vertices[i][2]);						
		}


		obj->facecount = model->numpolys;
		obj->arrayface = new face[obj->facecount];
		for (int i = 0;i < obj->facecount;i++)
		{
			//obj->arrayface[i] = new face();	
			obj->arrayface[i].nbtextures = 0;
			obj->arrayface[i].useNormalMap = false;
			obj->arrayface[i].nbvertices = 3;
			obj->arrayface[i].vertexindex[0] = model->polys[i].verts[0];
			obj->arrayface[i].vertexindex[1] = model->polys[i].verts[1];
			obj->arrayface[i].vertexindex[2] = model->polys[i].verts[2];	
			//computeNormal(&obj->arrayface[i], obj->vertices);
			//computeLocalSpace2();					
		}
		
		
		obj->texcoordscount = model->numuvmaps;
		obj->texcoords = new float[model->numuvmaps*2];
		for (int i = 0;i < obj->texcoordscount;i++)
		{
			obj->texcoords[i*2] = model->uvmaps[i].u;
			obj->texcoords[i*2+1] = model->uvmaps[i].v;			
		}		
		
		
		//printf("OBJ %d %d\n",obj->vertexcount,obj->facecount);
		//getchar();
		obj->facegroupcount = 1;
		obj->arrayfacegroup = new FaceGroup[1];
		//obj->arrayfacegroup[0].startVerticesIndex = 0;
		//obj->arrayfacegroup[0].endVerticesIndex = obj->vertexcount;
		obj->arrayfacegroup[0].uVertBufferOffset =obj->vertexcount;
		obj->arrayfacegroup[0].verticesCount = obj->vertexcount;
		//obj->arrayfacegroup[0].startFacesIndex = 0;
		//obj->arrayfacegroup[0].endFacesIndex = obj->facecount;
		obj->arrayfacegroup[0].uFaceIndexBufferOffset = obj->facecount;
		obj->arrayfacegroup[0].faceCount = obj->facecount;
		obj->arrayfacegroup[0].verticesPerFace = 3;
		obj->arrayfacegroup[0].texturesCount = 0;
		//obj->arrayfacegroup[0].startTexCoordsIndex = 0;
		//obj->arrayfacegroup[0].endTexCoordsIndex = 0;
		obj->arrayfacegroup[0].uTexCoordsBuffer = 0;
		obj->arrayfacegroup[0].texCoordsLayerCount = 0;
		obj->arrayfacegroup[0].texCoordsCount = 0;
		obj->arrayfacegroup[0].texcoordsBufferName = 0;
		obj->arrayfacegroup[0].colorBufferName = 0;
		obj->arrayfacegroup[0].useShader = false;
		obj->arrayfacegroup[0].hasNormalMap = false;
		obj->arrayfacegroup[0].hasTexture = false;
		
}


// Load3DS
//
// Load a .3ds file into memory for parsing
//
int Load3DS(char* filename)
{
    ifstream    file;
    bool        doneloading = false;
    int         filelength;
    char*       memfile;        // file loaded into memory
	
	printf("Load3DS: filename=%s\n",filename);
    // load entire file into memory (easier to deal with)
    file.open(filename, ios::binary);
    file.seekg(0, ios::end);
    filelength = file.tellg();
    memfile = new char[filelength];
    file.seekg(0, ios::beg);
    file.read(memfile, filelength);
    // parse it
    EatChunk(memfile);
    delete memfile;
    return 0;
}

// EatChunk
//
//  This function recursively handles chunks
// in a .3ds file.  When the function exits,
// the return value (i) should be the length
// of the current chunk.  Right now we only
// create one model (the first one listed in
// the file) and read in verts and polys only.
// To grab other info from the file, create
// a new case label in the switch statement
// for the chunk type you want to react to.
// 
/*
long EatChunk(char* buffer)
{
    short   chunkid;
    long    chunklength;
    int     i = 0;  // index into current chunk
    int     j;

    chunkid = *(short*)(buffer);
    chunklength = *(long*)(buffer+2);
    i = 6;
    switch (chunkid)
    {
    case 0x4D4D:    // main file
        while ((*(unsigned short*)(buffer+i) != (unsigned short)0x3D3D) &&
            (*(unsigned short*)(buffer+i) != (unsigned short)0xB000))
            i += 2;
        break;
    case 0x3D3D:    // editor data
        break;
    case 0x4000:    // object description
        while (*(buffer+(i++)) != 0);   // get past string description
        break;
    case 0x4100:    // triangular polygon list
        break;
    case 0x4110:    // vertex list
        if (g_model.numverts == 0)
        {
            g_model.numverts = *(short*)(buffer+i);
            i+=2;
            g_model.verts = new CVertex[g_model.numverts];
            for (j=0;j<g_model.numverts;j++)
            {
                g_model.verts[j].x = *(float*)(buffer+i);
                i+=4;
                g_model.verts[j].y = *(float*)(buffer+i);
                i+=4;
                g_model.verts[j].z = *(float*)(buffer+i);
                i+=4;
            }
        }
        else
            i = chunklength;
        break;
    case 0x4120:
        if (g_model.numpolys == 0)
        {
            g_model.numpolys = *(short*)(buffer+i);
            i+=2;
            g_model.polys = new CPolygon[g_model.numpolys];
            for (j=0;j<g_model.numpolys;j++)
            {
                g_model.polys[j].verts[0] = *(short*)(buffer+i);
                i+=2;
                g_model.polys[j].verts[1] = *(short*)(buffer+i);
                i+=2;
                g_model.polys[j].verts[2] = *(short*)(buffer+i);
                i+=2;
                i+=2;   // skip face info
            }
        }
        else
            i = chunklength;
        break;
    default:
        i = chunklength;    // skips over rest of chunk (ignores it)
        break;
    }

    // eat child chunks
    while (i < chunklength)
        i += EatChunk(buffer+i);
    return chunklength;
} 
*/
int EatChunk(char* buffer)
{
    short   chunkid;
    int    chunklength;
    int     i = 0;  // index into current chunk
    int     j;

    chunkid = *(short*)(buffer);
    chunklength = *(int*)(buffer+2);
    i = 6;
    switch (chunkid)
    {
    case 0x4D4D:    // main file
        while ((*(unsigned short*)(buffer+i) != (unsigned short)0x3D3D) &&
            (*(unsigned short*)(buffer+i) != (unsigned short)0xB000))
            i += 2;
        break;
    case 0x3D3D:    // editor data
        break;
    case 0x4000:    // object description
        while (*(buffer+(i++)) != 0);   // get past string description
        break;
    case 0x4100:    // triangular polygon list
        break;
    case 0x4110:    // vertex list
        if (g_model.numverts == 0)
        {
            g_model.numverts = *(short*)(buffer+i);
            i+=2;
            g_model.verts = new CVertex[g_model.numverts];
    		printf("Vertex Count: %d\n", g_model.numverts);             
            for (j=0;j<g_model.numverts;j++)
            {
                g_model.verts[j].x = *(float*)(buffer+i);
                i+=4;
                g_model.verts[j].y = *(float*)(buffer+i);
                i+=4;
                g_model.verts[j].z = *(float*)(buffer+i);
                i+=4;
            }
        }
        else
            i = chunklength;
        break;
    case 0x4120:
        if (g_model.numpolys == 0)
        {
            g_model.numpolys = *(short*)(buffer+i);
    		printf("Triangle Count: %d\n",g_model.numpolys);              
            i+=2;
            g_model.polys = new CPolygon[g_model.numpolys];
            for (j=0;j<g_model.numpolys;j++)
            {
                g_model.polys[j].verts[0] = *(short*)(buffer+i);
                i+=2;
                g_model.polys[j].verts[1] = *(short*)(buffer+i);
                i+=2;
                g_model.polys[j].verts[2] = *(short*)(buffer+i);
                i+=2;
                i+=2;   // skip face info
            }
        }
        else
            i = chunklength;
        break;
    case 0x4140:
    	printf("MAPPING COORDINATES LIST found %d\n",chunklength);
    	g_model.numuvmaps = *(short*)(buffer+i);
    	printf("UV MAPS Count: %d\n",g_model.numuvmaps);    	
            i+=2;
            //i+=4;
            g_model.uvmaps = new CUVMap[g_model.numuvmaps];
            for (j=0;j<g_model.numuvmaps;j++)
            {
                g_model.uvmaps[j].u = *(float*)(buffer+i);
                i+=4;
                g_model.uvmaps[j].v  = *(float*)(buffer+i);
                i+=4;
            }    	
        i = chunklength;
        break;    	
    default:
        i = chunklength;    // skips over rest of chunk (ignores it)
        break;
    }

    // eat child chunks
    while (i < chunklength)
        i += EatChunk(buffer+i);
    return chunklength;
} 


Importer3DS::Importer3DS(char * filename)
{
	strcpy(this->filename,filename);
	Load3DS(this->filename);	
}

void Importer3DS::setObject(object * obj)
{
	Model2Object(&g_model,obj);
	if (g_model.polys != NULL)	
	delete g_model.polys;
	if (g_model.uvmaps != NULL)
		delete g_model.uvmaps;
	if (g_model.verts != NULL)			
	delete g_model.verts;
	 g_model.numverts = 0;
	 g_model.numpolys = 0;
	 g_model.numuvmaps = 0;
}


object * GetObject(int index)
{
	return 0;
}

