#include "light.h"

light::light(void)
{
  radius = 200.;	
}

light::~light(void)
{
	
}

void light::set_color(float r,float g,float b)
{
  color(0) = r;
  color(1) = g;
  color(2) = b;	
}

void light::set_position(float x,float y,float z)
{
  position(0) = x;
  position(1) = y;
  position(2) = z;		
}

vector3f light::get_position(void)
{
	return position;
}

vector3f light::projection(vector3f vertex,float factor)
{
	vector3f res;
	vector3f::sub(res,vertex,this->position);
	res(0) = res(0) * factor;
	res(1) = res(1) * factor;
	res(2) = res(2) * factor;
	return res;
}

vector3f light::compute_pervertexlighting(vector3f position, vector3f normal,vector3f tangent, vector3f binormal)
{
	//vector3f tempVect = this->position - position;
	vector3f tempVect = position - this->position;
	
	//vector3f::sub(tempVect,this->position,position);	
	//tempVect.print();
	vector3f vertexToLight;
	vertexToLight(0) = tangent * tempVect;
	vertexToLight(1) = binormal * tempVect;
	vertexToLight(2) = normal * tempVect;
	//vertexToLight = vertexToLight * -1.0;
	//vertexToLight(2) = -vertexToLight(2);
	
	//normal.print();
	//tempVect.print();
	
	//vertexToLight.normalize();
	
	//vertexToLight.print();
	//tempVect.print();
	
	/*
	if (vertexToLight(0) < 0. )
		vertexToLight(0)  = -vertexToLight(0) ;
	if (vertexToLight(1) < 0. )
		vertexToLight(1)  = -vertexToLight(1) ;
	if (vertexToLight(2) < 0. )
		vertexToLight(2)  = -vertexToLight(2) ;	
	*/
	
	//printf("Vect: %f %f %f\n",vertexToLight(0),vertexToLight(1),vertexToLight(2));
	return vertexToLight;
}

vector3f light::compute_lighting(vector3f position, vector3f normal)
{
	// on calcul le verteur allant du vertex  la lumiere.
	vector3f vertexToLight = this->position - position;
	//vector3f::sub(vertexToLight,this->position,position);
	float attenuation = 1.0f - (vertexToLight.length() / radius);
	// on normalise le vecteur
	vertexToLight.normalize();
	// on calcul le produit scalaire
	//puts("ComputeLighting");
	//vertexToLight.print();
	//normal.print();
	//printf("scal: %f\n",vertexToLight*normal);
	attenuation *= vertexToLight*normal;
	if (attenuation < 0.)
	{
		attenuation = 0.;
	}
/*
	else if (attenuation > 0.5){
	  position.print();
	  normal.print();
	  printf("att: %f\n",attenuation);
		attenuation = 0.;
	}		
*/
	vector3f ret = this->color * attenuation;
	/*
	ret(0) *= attenuation;
	ret(1) *= attenuation;
	ret(2) *= attenuation;
	*/
	//ret.print();		
	return ret;
}
