/* Created by Anjuta version 1.2.2 */
/*	This file will not be overwritten */

#include <iostream>
#include "engine.h"
#include "terrain.h"
#include "texturedcube.h"
#include "image.h"
#include "image32.h"
#include "reversetexturedcube.h"

#include "gravity.h"
#include "resistance.h"
#include "plan.h"
#include "ei.h"
static int cId = 0;
cube * pCube[100];
int pCubeID[100];
/*
void process(void * args){
  engine * e = (engine *)args;
  float * vpos;
  static bool spaced = 0;
  if ((EI_keyb_space) && (spaced == 0)){
    for (int i =0; i < 100;i ++){
      vpos = pCube[i]->get_position();
      for (int k = 0; k < 100;k++){
          cube * nc = new cube(0.5,(float)(rand()%9)+1,vpos[0],vpos[1],vpos[2]);
          nc->set_speed((float)(rand()%10)-5.,(float)(rand()%10)-5.,(float)(rand()%10));
          nc->set_angularspeed((float)(rand()%1000)-500.,(float)(rand()%1000)-500.,(float)(rand()%1000)-500.);
          e->add_mobile(nc,cId);
          
      }
      e->remove_mobile(pCubeID[i]);
  
    }
    spaced = 1;
  }
}
*/

void cube_explode(int id, engine * e){
     
     float * vpos;
     float r = (float)(rand()%100) / 100.;
     float g = (float)(rand()%100) / 100.;
     float b = (float)(rand()%100) / 100.;
      vpos = pCube[id]->get_position();
      int borne = (rand()%100);
      for (int k = 0; k < borne;k++){
          cube * nc = new cube(0.5,(float)(rand()%9)+1,vpos[0],vpos[1],vpos[2]);
          nc->set_speed((float)(rand()%10)-5.,(float)(rand()%10)-5.,(float)(rand()%10));
          nc->set_angularspeed((float)(rand()%1000)-500.,(float)(rand()%1000)-500.,(float)(rand()%1000)-500.);
          nc->set_color(r,g,b);
          nc->set_listable(true);
          e->add_mobile(nc,cId);
      }
      
      int res;
      res = e->remove_mobile(pCubeID[id]);
      pCube[id] = NULL;
}


void process(void * args){
  engine * e = (engine *)args;
  float * vpos;
  static int fpscount = 0; 
  static int timeold = 0;
  static bool spaced = 0;
  if ((EI_keyb_space) && (spaced == 0)){
    /*
    for (int i =0; i < 100;i ++){  
      }
      
    }
    */
    spaced = 1;
  }
  object * o;

  
  for (int i =0; i < 100;i++){
     if (pCube[i] != NULL){ 
     vpos = pCube[i]->get_position();
     if (vpos[2] > 10){
        cube_explode(i, e);
     } else if (vpos[2] < -5.){
           e->remove_mobile(pCubeID[i]);
           pCube[i] = NULL;
            }
     } else {
      
       pCube[i] = new cube(1.,(float)(rand()%100),(float)(rand()%100),0);
       pCube[i]->set_speed((float)(rand()%10)-5.,(float)(rand()%10)-5.,(float)(rand()%10)+5.);
       pCube[i]->set_color(0.0,0.0,0.0);   
       pCubeID[i] = e->add_mobile(pCube[i],cId);  
          
       }
  }
  
   for (int i = 0;i < 10000;i++)
    if ((o = e->get_mobile(i)) != NULL){
      vpos = o->get_position();
      if (vpos[2] < - 5.)
        e->remove_mobile(i);
    }
    
    
    
    int timenow =  EI_getticks();
    if (timenow - timeold > 10000){
      printf("FPS:%f Objects:%d\n",((float)(fpscount))/10.,e->get_entitycount());
      timeold = timenow;
      fpscount = 0;
    }
    fpscount++;
     
}



int main(int argc, char **argv)
{
    int w = 800;
    int h = 600;
    int f = 0;
    for (int i = 0;i < argc;i++){
      if (argv[i][0] == '-'){
        switch (argv[i][1]){
          case 'w' : w = atoi(argv[i]+2);break;
          case 'h': h = atoi(argv[i]+2);break;
          case 'f' : f = 1;break;
          default : return 0;
        }
      }
    }
    if ((w&&h) == 0)
      return 0;
    
	printf("test");
	engine * e;
	terrain * t;
	texturedcube * c;
	texturedcube * c2;
	cube * c1;
	plan * p;
    
	
	
	e = new engine();
	e->init(w,h,f);
	p = new plan(100.,0.,0.,-3.);
	
	//t = new terrain(100,100,0,0,0);
	c = new reversetexturedcube(200.,0.,0.,0.);
	c->set_position(0.,0.,0.);
	//c2 = new texturedcube(1.,0.,0.,0);
	//c1 = new cube(5.,0.,0.,10.);
	
	/*
	terrain * arrT[64];
	for (int u = 0;u < 8;u++)
	  for (int v = 0;v < 8;v++){
        arrT[u + v*8] = new terrain(64,64,u*64 - 256,v*64 - 256,-20);
        //arrT[u + v*8]->set_listable(false);
        e->add_object(arrT[u + v*8]);
      }
      
    
	
    //t = new terrain(2,512,0,0,-20);
	*/
	
	c->settexture("up.bmp",0);
	c->settexture("dn.bmp",1);
	c->settexture("lt.bmp",2);
	c->settexture("ft.bmp",3);
	c->settexture("rt.bmp",4);
	c->settexture("bk.bmp",5);
    c->set_orientation(180,0,0);
	
	/*
    c2->settexture("face01.bmp",0);
	c2->settexture("face02.bmp",1);
	c2->settexture("face03.bmp",2);
	c2->settexture("face04.bmp",3);
	c2->settexture("face05.bmp",4);
	c2->settexture("face06.bmp",5);
	*/
	
    for (int i = 0;i < 100;i ++){
      pCube[i] = new cube(1.,(float)(rand()%100),(float)(rand()%100),0);
      pCube[i]->set_speed((float)(rand()%10)-5.,(float)(rand()%10)-5.,(float)(rand()%10)+5);
      //pCubeID[i] = e->add_mobile(pCube[i]);
      pCube[i]->set_color(0.,0.,0.);
      
      if (cId == 0){
         pCubeID[i] = e->add_mobile(pCube[i]);
         
         //cId = pCubeID[i];
         //printf("cId: %d\n",cId);
         cId = pCube[i]->get_idlist();;
      } else pCubeID[i] = e->add_mobile(pCube[i],cId);
      
         //pCubeID[i] = e->add_mobile(pCube[i]);
    }
	//image32 * img = new image32("face01.bmp");
 /*
	for(int i = 0;i <10;i++)
	  for(int j = 0;j < 10;j++){
        e->add_object(new terrain(100,100,i*100,j*100,0));  
	  }
   */  
    //printf("test2");
    //c->set_speed(0.,1.,0.);
	
    e->add_object(p);
	
    e->add_object((object*)c);
    
    //t->set_listable(true);
    //e->add_object(t);    
	//e->add_mobile(c2);
	
    e->add_force(new gravity());
	e->set_processcallback(&process,e);
	
    
    //e->add_force(new resistance(0.1));
	//e->add_object(c2);
	//e->add_object(c1);
	e->mainloop();
	return 0;
}
