#include "object3ds.h"
#include "importer3ds.h"
#include <stdio.h>
#include <string.h>
#include "face.h"
#include "image24.h"
#include "vector3f.h"

Object3ds::Object3ds(float x,float y,float z,char * filename):mobile(1,x,y,z)
{
	strcpy(this->m_sFilename,filename);
	Importer3DS importer = Importer3DS(this->m_sFilename);
	//printf("BEFORE IMPORT %d\n",this->vertexcount);
	importer.setObject(this);
	//printf("AFTER IMPORT %d\n",this->vertexcount);	
	
    this->normals =new float*[this->vertexcount];
    for (int k = 0;k < this->vertexcount;k++)
    {
	       this->normals[k] = new float[3];	
	       this->normals[k][0] = 0.;
	       this->normals[k][1] = 0.;
	       this->normals[k][2] = 0.;	       
   }
       
       this->binormals =new float*[this->vertexcount];
       for (int k = 0;k < this->vertexcount;k++)
       {
	       this->binormals[k] = new float[3];
	       this->binormals[k][0] = 0.;
	       this->binormals[k][1] = 0.;
	       this->binormals[k][2] = 0.;	       
       }	       
       
        this->tangents =new float*[this->vertexcount];
       for (int k = 0;k < this->vertexcount;k++)
       {
	       this->tangents[k] = new float[3];
	       this->tangents[k][0] = 0.;
	       this->tangents[k][1] = 0.;
	       this->tangents[k][2] = 0.;	       
       }	
    for (int i = 0;i < this->facecount;i++)
    {	
		computeLocalSpace2(&this->arrayface[i],this->vertices, this->normals,this->binormals, this->tangents);
    }
    
    for (int k = 0;k < this->vertexcount;k++)
    {	
    	   vector3f n = vector3f(this->normals[k]);
    	   //if (n.length() > 1.)
    	   //printf("length: %f\n",n.length());	
    	   
    	   n.normalize();
 	       this->normals[k][0] = n(0);
	       this->normals[k][1] = n(1);
	       this->normals[k][2] = n(2);          
   }        
	this->set_listable(false);
	this->hasShadow = false;
}

Object3ds::~Object3ds()
{
	
}


