#include "quad.h"
#include "ei.h"
#include <stdio.h>

Quad::Quad(float fXTop, float fYTop, float fXBottom, float fYBottom,float fZ):
mobile(0.,(fXTop + fXBottom)/2.,(fYTop + fYBottom)/2.,fZ)
//mobile(0.,0.,0.,0.)
{

  float fH = (fYTop + fYBottom)/2.;
  float fW = (fXTop + fXBottom)/2.;

   this->vVertices[0][0] = fXTop - fW;
   this->vVertices[0][1] = fYTop - fH;
   this->vVertices[0][2] = 0.;

   this->vVertices[1][0] = fXBottom - fW;
   this->vVertices[1][1] = fYTop - fH;
   this->vVertices[1][2] = 0.;

   this->vVertices[2][0] = fXBottom - fW ;
   this->vVertices[2][1] = fYBottom - fH;
   this->vVertices[2][2] = 0.;

   this->vVertices[3][0] = fXTop - fW;
   this->vVertices[3][1] = fYBottom - fH;
   this->vVertices[3][2] = 0.;

   

/*
   this->vVertices[0][0] = fXTop;
   this->vVertices[0][1] = fYTop;
   this->vVertices[0][2] = fZ;

   this->vVertices[1][0] = fXBottom;
   this->vVertices[1][1] = fYTop;
   this->vVertices[1][2] = fZ;

   this->vVertices[2][0] = fXBottom;
   this->vVertices[2][1] = fYBottom;
   this->vVertices[2][2] = fZ;

   this->vVertices[3][0] = fXTop;
   this->vVertices[3][1] = fYBottom;
   this->vVertices[3][2] = fZ;
*/
   this->setTexCoordBottom(1.,1.);
   this->setTexCoordTop(0.,0.);

/*
   this->vVertices[0][0] = 1.;
   this->vVertices[0][1] = 1.;
   this->vVertices[0][2] = -5.;
   this->vVertices[1][0] = -1.;
   this->vVertices[1][1] = 1.;
   this->vVertices[1][2] = -5.;
*/

  //glVertex3f(1.,1.,-5.);
  //glVertex3f(-1.,1.,-5.);
  //glVertex3f(0,-2.,-5.);

   this->hasTexture = false;
   this->listable = false;
/*
   for (int i = 0;i < 4;i++)
   {
      printf("Point: %f %f %f %f\n",this->vVertices[i][0],this->vVertices[i][1],this->vVertices[i][2],this->vVertices[i][3]);
   }
*/
}

Quad::~Quad()
{

}

void Quad::settexture(int iTextureID)
{
  this->hasTexture = true;
  this->iTextureID = iTextureID;
  if (iTextureID < 0)
  {
     printf("Invalid texture\n");
  }
}

void Quad::setTexCoordTop(float fX,float fY)
{
  this->vTexCoord[0][0] = fX;
  this->vTexCoord[0][1] = fY;
}
void Quad::setTexCoordBottom(float fX,float fY)
{
  this->vTexCoord[1][0] = fX;
  this->vTexCoord[1][1] = fY;
}

#include <stdio.h>
void Quad::draw(void)
{

  if (this->hasTexture){
	EI_set_inactive_texture1();
	EI_set_active_texture0(); 
	EI_bind_2D_texture(this->iTextureID);
   } 
  EI_setcolor(1.,1.,1.);
  EI_begin_quad();
   
  EI_texcoord_f(this->vTexCoord[1][0],this->vTexCoord[0][1]);
 EI_vertex(this->vVertices[0][0],this->vVertices[0][1],this->vVertices[0][2]);
  EI_texcoord_f(this->vTexCoord[0][0],this->vTexCoord[0][1]);
  EI_vertex(this->vVertices[1][0],this->vVertices[1][1],this->vVertices[1][2]);
  EI_texcoord_f(this->vTexCoord[0][0],this->vTexCoord[1][1]);
  EI_vertex(this->vVertices[2][0],this->vVertices[2][1],this->vVertices[2][2]);
  EI_texcoord_f(this->vTexCoord[1][0],this->vTexCoord[1][1]);
  EI_vertex(this->vVertices[3][0],this->vVertices[3][1],this->vVertices[3][2]);
   
  EI_end();

/*
  EI_begin_quad();
  //EI_normal(0,0,-1);
  EI_texcoord_i(1,0);
  EI_vertex(this->vVertices[0][0],this->vVertices[0][1],this->vVertices[0][2]);
  EI_texcoord_i(0,0);
  EI_vertex(this->vVertices[1][0],this->vVertices[1][1],this->vVertices[1][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vVertices[2][0],this->vVertices[2][1],this->vVertices[2][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vVertices[3][0],this->vVertices[3][1],this->vVertices[3][2]);
  EI_end();
*/
}

void Quad::render(){      
/* 
	if (this->is_listable()){
        //EI_scale(this->size,this->size,this->size);
        //EI_setcolor(this->color[0],this->color[1],this->color[2]);
        EI_call_list(this->get_idlist());
      }
      else {
        //EI_scale(this->size,this->size,this->size);
        //EI_setcolor(this->color[0],this->color[1],this->color[2]);
*/

      EI_push_matrix();      
       EI_translate(this->get_position()[0],
                  this->get_position()[1],
                 this->get_position()[2]);       
    
         EI_rotate(this->get_orientation()[0],
                this->get_orientation()[1],
                this->get_orientation()[2]);  

        this->draw();
       EI_pop_matrix(); 
   //        } 
           
}
