#include "image.h"
#include "image32.h"
#include "reversetexturedcube.h"

#include <stdio.h>
#include "ei.h"

#include "vector3f.h"

reversetexturedcube::reversetexturedcube(float size,float x,float y,float z) : texturedcube(size,x,y,z)
{  
	const int f0[4] = {3,2,1,0};
	const int f1[4] = {5,6,7,4};
	const int f2[4] = {7,6,2,3};
	const int f3[4] = {4,7,3,0};
	const int f4[4] = {0,1,5,4};
	const int f5[4] = {5,1,2,6};
	
	for (int i =0;i < 4;i++)
	{
		this->arrayface[0].vertexindex[i] = f0[i];
		this->arrayface[1].vertexindex[i] = f1[i];
		this->arrayface[2].vertexindex[i] = f2[i];
		this->arrayface[3].vertexindex[i] = f3[i];		
		this->arrayface[4].vertexindex[i] = f4[i];
		this->arrayface[5].vertexindex[i] = f5[i];		
	}      
	
      for (int i = 0;i < 6;i++)
       {
		vector3f res;
		vector3f vm1;
		vector3f vm2;
		vector3f v0 = vector3f(this->vertices[this->arrayface[i].vertexindex[0]]);
		vector3f v1 = vector3f(this->vertices[this->arrayface[i].vertexindex[1]]);
		vector3f v2 = vector3f(this->vertices[this->arrayface[i].vertexindex[2]]);       
		vector3f::sub(vm1,v1,v0);
		vector3f::sub(vm2,v2,v0);
		vector3f::vect(res,vm1,vm2);
		res.normalize();
		res.print();
	        this->arrayface[i].normal[0] = res(0);       
		this->arrayface[i].normal[1] = res(1);       
		this->arrayface[i].normal[2] = res(2);   
       }	
       /*
	for (int i = 0;i < 6;i++)
	{
		this->texcoords [6+i*6] = 0.;
		this->texcoords [7+i*6] = 0.;
		this->texcoords [4+i*6] = 1.;
		this->texcoords [5+i*6] = 0.;		
		this->texcoords [2+i*6] = 1.;
		this->texcoords [3+i*6] = 1.;
		this->texcoords [0+i*6] = 0.;
		this->texcoords [1+i*6] = 1.;		
	}    
	*/  
	/*
		this->texcoords [6+5*6] = 1.;
		this->texcoords [7+5*6] = 0.;
		this->texcoords [4+5*6] = 1.;
		this->texcoords [5+5*6] = 1.;		
		this->texcoords [2+5*6] = 0.;
		this->texcoords [3+5*6] = 1.;
		this->texcoords [0+5*6] = 0.;
		this->texcoords [1+5*6] = 0.;	
	*/	 
	/*
		this->texcoords [6+5*6] = 1.;
		this->texcoords [7+5*6] = 1.;
		this->texcoords [4+5*6] = 0.;
		this->texcoords [5+5*6] = 1.;		
		this->texcoords [2+5*6] = 0.;
		this->texcoords [3+5*6] = 0.;
		this->texcoords [0+5*6] = 1.;
		this->texcoords [1+5*6] = 0.;	
		*/
		/*
		this->arrayface[0].texCoords[6] = 2.;
		this->arrayface[0].texCoords[7] = 2.;
		this->arrayface[0].texCoords[4] = 0.;
		this->arrayface[0].texCoords[5] = 2.;		
		this->arrayface[0].texCoords[2] = 0.;
		this->arrayface[0].texCoords[3] = 0.;
		this->arrayface[0].texCoords[0] = 2.;
		this->arrayface[0].texCoords[1] = 0.;		
		*/
		this->arrayface[0].texCoords[6] = 1.;
		this->arrayface[0].texCoords[7] = 1.;
		this->arrayface[0].texCoords[4] = 0.;
		this->arrayface[0].texCoords[5] = 1.;		
		this->arrayface[0].texCoords[2] = 0.;
		this->arrayface[0].texCoords[3] = 0.;
		this->arrayface[0].texCoords[0] = 1.;
		this->arrayface[0].texCoords[1] = 0.;			
		
		this->arrayface[5].texCoords[6] = 0.;
		this->arrayface[5].texCoords[7] = 1.;
		this->arrayface[5].texCoords[4] = 0.;
		this->arrayface[5].texCoords[5] = 0.;		
		this->arrayface[5].texCoords[2] = 1.;
		this->arrayface[5].texCoords[3] = 0.;
		this->arrayface[5].texCoords[0] = 1.;
		this->arrayface[5].texCoords[1] = 1.;				
	
}

reversetexturedcube::~reversetexturedcube()
{
}

/*
void reversetexturedcube::settexture(char * filename, int idface)

{

  this->textures[idface] = new image32(filename);
  //int i = this->textures_id[idface];

  EI_gen_textures(1,&this->textures_id[idface]);

  

  int nb = 0;

  printf("Texture %d name: %d\n",idface,this->textures_id[idface]);

  printf("Texture width: %d\n",this->textures[idface]->get_width());

  printf("Texture heigth: %d\n",this->textures[idface]->get_heigth());

  for (int i = 0; i < this->textures[idface]->get_width()*this->textures[idface]->get_heigth()*3;i++){

    nb += (int)this->textures[idface]->get_pixels()[i];

  }
   

  EI_bind_2D_texture(this->textures_id[idface]);



  EI_tex_image2d(this->textures[idface]->get_pixels(),

                this->textures[idface]->get_width(),

                this->textures[idface]->get_heigth(),

                this->textures_id[idface]);

}
*/




void reversetexturedcube::draw(void)
{
     
  //EI_setcolor(1.0,1.0,1.0);
  EI_enable_texture();
  //EI_bind_2D_texture(this->textures_id[0]);
  EI_bind_2D_texture(this->arrayface[0].textureids[0]);
  EI_begin_quad();

  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]); 
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);

  EI_end();  
  
//  /EI_bind_2D_texture(this->textures_id[1]); 
  EI_bind_2D_texture(this->arrayface[1].textureids[0]);
  EI_begin_quad(); 

  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);

  EI_end();
  //EI_bind_2D_texture(this->textures_id[2]);
  EI_bind_2D_texture(this->arrayface[2].textureids[0]);
  EI_begin_quad();

  EI_texcoord_i(1,1);  
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  
  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  
  EI_end();  

  //EI_bind_2D_texture(this->textures_id[3]);  
  EI_bind_2D_texture(this->arrayface[3].textureids[0]);
  EI_begin_quad();
  
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
   
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  
  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);

  EI_end();    

  //EI_bind_2D_texture(this->textures_id[4]);
  EI_bind_2D_texture(this->arrayface[4].textureids[0]);
  EI_begin_quad();

  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]); 
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_texcoord_i(0,0);
  
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]);
  EI_texcoord_i(1,0);
  
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);

  EI_end();    

  //EI_bind_2D_texture(this->textures_id[5]);
  EI_bind_2D_texture(this->arrayface[5].textureids[0]);

  EI_begin_quad();

  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_texcoord_i(0,0);
  
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_texcoord_i(1,0);
  
  
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 
  EI_end();

/*
  EI_begin_quad();
  EI_texcoord_i(0,0);

  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_texcoord_i(1,1);
  
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);

    EI_texcoord_i(0,1);
  
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 
  EI_end();
*/
}

void reversetexturedcube::render(void)
{

      if (this->is_listable()){
        //printf("listid : %d\n",this->get_idlist());
        EI_call_list(this->get_idlist());
        }
      else this->draw();   
}

