//
// File: terrain.cc
// Created by: User <Email>
// Created on: Thu Nov 25 00:32:07 2004
//

#include "terrain.h"
#include "ei.h"
#include <stdlib.h>
#include <stdio.h>
#include "vector3f.h"
#include <string.h>
void EI_begin_triangle(void);
void EI_vertex(float x,float y,float z);
void EI_end(void);
void EI_setcolor(float r,float g,float b);
void blur_heightmap(unsigned short * heightmap,int width,int length);



unsigned short * generate_heightmap(int width,int length){
    unsigned short int * heightmap = new unsigned short[width*length];
	for (int i = 0;i < width*length;i++)
	  heightmap[i] = 1;

	for (int i = 1;i < width-1;i++)
		for (int j = 1;j < length-1;j++)
	      heightmap[i+j*length] = rand()%30000;
      return heightmap;
}
unsigned short heightmap_max(unsigned short * heightmap,int width,int length){
  unsigned short max = heightmap[0];
	for (int i = 1;i < width*length;i++)
      if (max < heightmap[i])
        max = heightmap[i];
    return max;
}

unsigned short heightmap_min(unsigned short * heightmap,int width,int length){
  unsigned short min = heightmap[0];
	for (int i = 1;i < width*length;i++)
      if (min > heightmap[i])
        min = heightmap[i];
    return min;
}

void blur_heightmap(unsigned short * heightmap,int width,int length){
    for (int i = 1;i < width-1;i++)
      for (int j = 1;j < length-1;j++){
   	    heightmap[i+j*length] = (unsigned short)(((float)heightmap[i+1+j*length] +
        heightmap[i+(j+1)*length] + heightmap[i+j*length] +
        heightmap[i-1+j*length] + heightmap[i+1+(j-1)*length])/5.);
      }
}

void terrain::generate_texture(int w,int h)
{
	this->texturepixels = new unsigned char[w*h*3];
	for (int i = 0;i < w*h;i++)
	{
		this->texturepixels[i*3] = 0;
		this->texturepixels[i*3 + 1] = 100;
		this->texturepixels[i*3 + 2] = 0;
	}
}


void merge_heightmap(unsigned short * heightmap, unsigned short * heightmap2,float factor,int width,int length,
    int width2, int length2){
  for (int i = 0;i < width;i++)
    for (int j = 0;j < length;j++){
        int x = (int)((i*width2)/(float)width);
        int y = (int)((j*length2)/(float)length);
        //heightmap[i+j*width] = (unsigned short)(heightmap2[x+y*length2]*factor) + heightmap[i+j*width];
        heightmap[i+j*width] = (unsigned short)(heightmap[i+j*width]*factor) + heightmap2[x+y*length2];
    }
  /*
  for (int i = 0;i < width;i++){
    heightmap[i] = 0;
    heightmap[i+(width-1)*width] = 0;
  }
  for (int i = 0;i < length;i++){
    heightmap[i*width] = 0;
    heightmap[i+width] = 0;
  } */
}

terrain::terrain(int width,int length,float x ,float y ,float z,unsigned short int * data): mobile(1,x,y,z)
{
	strcpy(this->name,"TERRAIN");
	printf ("terrain: %f %f %f\n",x,y,z);
	int i;
	int j;
	this->width = width;
	this->length = length;
	this->heightmap = data;
	this->listable = false;

	//Vertices allocation
	int nb_vertices = width*length*6;
	this->vertexcount = nb_vertices;

	this->texcoords = new float[nb_vertices * 2];
	this->texcoordscount = nb_vertices;
	this->vertices = new float*[nb_vertices];
	for (i =0;i < nb_vertices;i++)
		this->vertices[i] = new float[3];

	//Faces allocation
	this->facecount = (width-1)*(length-1)*2;
	printf("Face count: %d\n",this->facecount);

	this->arrayface = new face[facecount];
	for (int i = 0 ; i <facecount;i++)
	{
		this->arrayface[i].nbvertices = 3;
		this->arrayface[i].nbtextures = 0;
	}

	/*
	this->facesindex = new int*[this->facecount];
	for (i = 0;i < this->facecount;i++)
		this->facesindex[i] = new int[3];
	*/


	//unsigned max = 3;
	unsigned short max = heightmap_max(heightmap,width,length);
	printf("max= %d\n",max);
	//int max = 1;
	max = 32768;
	int facecounter = 0;
	for (i = 0;i < width-1;i++)
	  for(j = 0;j < length-1;j++){
	     float deniv = 24.;

		int offset =  (i+j*length)*6;
	    this->vertices[offset][0] = (float)i-( (width-1) /2);
	    this->vertices[offset][1] = (float)j-( (length-1) /2);
	    /*
	    if ((i == 0)&&(j==0))
	    {
			printf("TOP element: %f %f\n",this->vertices[offset][0] + x,this->vertices[offset][0] + y);
	    }
		*/
	    this->vertices[offset][2] = ((float)heightmap[i+j*length]/max)*deniv;

		this->texcoords[offset*2] = 1./(float)width * i;
		this->texcoords[offset*2+1] = 1./(float)width * j;

	    //this->vertices[(i+j*length)*6][2] = deniv;
	    //this->vertices[(i+j*length)*6][3] = heightmap[i+j*length]/(float)max;


	    this->vertices[offset+1][0] = (float)i+1-( (width-1)/2);
	    this->vertices[offset+1][1] = (float)j-( (length-1) /2);
	    this->vertices[offset+1][2] = ((float)heightmap[i+1+j*length]/max)*deniv;

		this->texcoords[(offset+1)*2] = 1./(float)width * (i+1);
		this->texcoords[(offset+1)*2+1] = 1./(float)width * j;

 	    //this->vertices[(i+j*length)*6+1][2] = deniv;
	    //this->vertices[(i+j*length)*6+1][3] = heightmap[i+1+j*length]/(float)max;



	    this->vertices[offset+2][0] = (float)i+1-( (width-1) /2);
	    this->vertices[offset+2][1] = (float)j+1-( (length-1) /2);
	    this->vertices[offset+2][2] = (float)heightmap[i+1+(j+1)*length]/max*deniv;
   	    //this->vertices[(i+j*length)*6+2][2] = deniv;
	    //this->vertices[(i+j*length)*6+2][3] = heightmap[i+1+(j+1)*length]/(float)max;
	    /*
	    if ((i ==  width-2)&&(j== length-2))
	    {
			printf("BOTTOM element: %f %f\n", this->vertices[offset+2][0] + x,this->vertices[offset+2][1] + y);
	    }
	    */

		this->texcoords[(offset+2)*2] = 1./(float)width * (i+1);
		this->texcoords[(offset+2)*2+1] = 1./(float)width * (j+1);


		 this->arrayface[facecounter].vertexindex[0] = (i+j*length)*6;
		 this->arrayface[facecounter].vertexindex[1]  = (i+j*length)*6 + 1;
		 this->arrayface[facecounter].vertexindex[2] = (i+j*length)*6 + 2;
	    /*
		this->facesindex[facecounter][0]  = (i+j*length)*6;
		this->facesindex[facecounter][1]  = (i+j*length)*6 + 1;
		this->facesindex[facecounter][2]  = (i+j*length)*6 + 2;
		*/
			this->arrayface[facecounter].nbvertices = 3;
	facecounter++;



	    this->vertices[offset+3][0] = (float)i+1-( (width-1) /2);
	    this->vertices[offset+3][1] = (float)j+1-( (length-1) /2);
	    this->vertices[offset+3][2] = (float)heightmap[i+1+(j+1)*length]/max*deniv;

	    //this->vertices[(i+j*length)*6+3][2] = deniv;
	   // this->vertices[(i+j*length)*6+3][3] = heightmap[i+1+(j+1)*length]/(float)max;
		this->texcoords[(offset+3)*2] = 1./(float)width * (i+1);
		this->texcoords[(offset+3)*2+1] = 1./(float)width * (j+1);



	    this->vertices[offset+4][0] = (float)i-( (width-1)/2);
	    this->vertices[offset+4][1] = (float)j+1-( (length-1) /2);
	    this->vertices[offset+4][2] = (float)heightmap[i+(j+1)*length]/max*deniv;
	    //this->vertices[(i+j*length)*6+4][2] = deniv;
	    //this->vertices[(i+j*length)*6+4][3] = heightmap[i+(j+1)*length]/(float)max;
		this->texcoords[(offset+4)*2] = 1./(float)width * i;
		this->texcoords[(offset+4)*2+1] = 1./(float)width * (j+1);



	    this->vertices[offset+5][0] = (float)i-( (width-1) /2);
	    this->vertices[offset+5][1] = (float)j-( (length-1) /2);
	    this->vertices[offset+5][2] = (float)heightmap[i+j*length]/max*deniv;

		this->texcoords[(offset+5)*2] = 1./(float)width * i;
		this->texcoords[(offset+5)*2+1] = 1./(float)width * j;

	    //this->vertices[(i+j*length)*6+5][2] = deniv;
	    //this->vertices[(i+j*length)*6+5][3] = heightmap[i+j*length]/(float)max;
	    /*
		this->facesindex[facecounter][0]  = (i+j*length)*6 + 3;
		this->facesindex[facecounter][1]  = (i+j*length)*6 + 4;
		this->facesindex[facecounter][2]  = (i+j*length)*6 + 5;
		*/
		 this->arrayface[facecounter].vertexindex[0] = (i+j*length)*6 + 3;
		 this->arrayface[facecounter].vertexindex[1]  = (i+j*length)*6 + 4;
		 this->arrayface[facecounter].vertexindex[2] = (i+j*length)*6 + 5;
		this->arrayface[facecounter].nbvertices = 3;
	facecounter++;
//printf("facecount: %d\n",	facecounter);
	  }



	int countmerged = 0;
	for (int i = 0;i < this->facecount;i++)
		{
			for (int j = 0;j < 3;j++)
			{
				int index = this->arrayface[i].vertexindex[j];
				for (int l = 0;l < index;l++)
				{
					if (this->vertices[index][0] == this->vertices[l][0])
							if (this->vertices[index][1] == this->vertices[l][1])
								if (this->vertices[index][2] == this->vertices[l][2])
								{
									//printf("%d = %d\n",index,l );
									//printf("removing %d\n",index);
									this->arrayface[i].vertexindex[j] = l;

									countmerged++;
									break;
								}
					}
			}
		}

	printf("terrain: %d vertices merged\n",countmerged);

	//Normal allocation and compuation
	//this->normals = new float*[this->facecount];
	/*
	for (i = 0;i < this->facecount;i++)
	{
	//printf("%d: %d %d %d\n",i,this->arrayface[i].vertexindex[0],this->arrayface[i].vertexindex[1],this->arrayface[i].vertexindex[2]);
		//this->arrayface[i].n = new float[3];
		vector3f res;
		vector3f vm1;
		vector3f vm2;
		vector3f v0 = vector3f(this->vertices[ this->arrayface[i].vertexindex[0]]);
		vector3f v1 = vector3f(this->vertices[ this->arrayface[i].vertexindex[1]]);
		vector3f v2 = vector3f(this->vertices[ this->arrayface[i].vertexindex[2]]);
		vector3f::sub(vm1,v1,v0);
		vector3f::sub(vm2,v2,v0);
		vector3f::vect(res,vm1,vm2);
		res.normalize();

		this->arrayface[i].normal[0] = res(0);
		this->arrayface[i].normal[1]  = res(1);
		this->arrayface[i].normal[2]  = res(2);

		//res.print();

	}
	*/
	this->orientation[0]  = 100.;

	//this->generate_texture(32,32);
	//this->settexture(this->texturepixels,32,32);

	this->facegroupcount = 0;
	//this->texcoordscount = 0;

	this->facegroupcount = 1;
	this->arrayfacegroup = new FaceGroup[1];
	this->arrayfacegroup[0].uVertBufferOffset =this->vertexcount;
	this->arrayfacegroup[0].verticesCount = this->vertexcount;
	this->arrayfacegroup[0].uFaceIndexBufferOffset = this->facecount;
	this->arrayfacegroup[0].faceCount = this->facecount;
	this->arrayfacegroup[0].verticesPerFace = 3;
	this->arrayfacegroup[0].texturesCount = 0;
	this->arrayfacegroup[0].uTexCoordsBuffer = 0;
	this->arrayfacegroup[0].texCoordsLayerCount = 0;
	this->arrayfacegroup[0].texCoordsCount = 0;
	this->arrayfacegroup[0].texcoordsBufferName = 0;
	this->arrayfacegroup[0].colorBufferName = 0;
	this->arrayfacegroup[0].useShader = false;
	this->arrayfacegroup[0].hasNormalMap = false;
	this->arrayfacegroup[0].hasTexture = false;
	this->arrayfacegroup[0].useSoftwareTransform = false;
	//this->arrayfacegroup[0].useShader = true;



	this->arrayfacegroup[0].position[0] = x;
	this->arrayfacegroup[0].position[1] = y;
	this->arrayfacegroup[0].position[2] = z;



    this->normals =new float*[this->vertexcount];
    for (int k = 0;k < this->vertexcount;k++)
    {
	       this->normals[k] = new float[3];
	       this->normals[k][0] = 0.;
	       this->normals[k][1] = 0.;
	       this->normals[k][2] = 0.;
   }

       this->binormals =new float*[this->vertexcount];
       for (int k = 0;k < this->vertexcount;k++)
       {
	       this->binormals[k] = new float[3];
	       this->binormals[k][0] = 0.;
	       this->binormals[k][1] = 0.;
	       this->binormals[k][2] = 0.;
       }

        this->tangents =new float*[this->vertexcount];
       for (int k = 0;k < this->vertexcount;k++)
       {
	       this->tangents[k] = new float[3];
	       this->tangents[k][0] = 0.;
	       this->tangents[k][1] = 0.;
	       this->tangents[k][2] = 0.;
       }
    for (int i = 0;i < this->facecount;i++)
    {
		computeLocalSpace2(&this->arrayface[i],this->vertices, this->normals,this->binormals, this->tangents);
    }

    for (int k = 0;k < this->vertexcount;k++)
    {



    	   /*
	       this->normals[k][0] = this->normals[k][0]/3.;
	       this->normals[k][1] = this->normals[k][1]/3.;
	       this->normals[k][2] = this->normals[k][2]/3.;
    	   */
    	   vector3f n = vector3f(this->normals[k]);
    	   //if (n.length() > 1.)
    	   //printf("length: %f\n",n.length());

    	   n.normalize();
 	       this->normals[k][0] = n(0);
	       this->normals[k][1] = n(1);
	       this->normals[k][2] = n(2);
   }
}

terrain::terrain(int width,int length,float x,float y,float z) : mobile(1,x,y,z)
{
	strcpy(this->name,"TERRAIN");
	int i;
	int j;
	unsigned short int * heightmap = generate_heightmap(width,length);
	unsigned short int * heightmap2 = generate_heightmap(width>>1,length>>1);
	unsigned short int * heightmap3 = generate_heightmap(width>>2,length>>2);
	unsigned short int * heightmap4 = generate_heightmap(width>>4,length>>4);
	//unsigned short int * heightmap5 = generate_heightmap(width,length);


	//blur_heightmap(heightmap4,width>>4,length>>4);
	//blur_heightmap(heightmap4,width>>4,length>>4);
	//blur_heightmap(heightmap4,width>>4,length>>4);
	//blur_heightmap(heightmap,width,length);
	//blur_heightmap(heightmap,width,length);
	//blur_heightmap(heightmap,width,length);

	//blur_heightmap(heightmap3,width>>2,length>>2);
	//blur_heightmap(heightmap2,width>>1,length>>1);

	//blur_heightmap(heightmap4,width>>4,length>>4);
	merge_heightmap(heightmap3, heightmap4, 0.1, width>>3,length>>3,width>>4,length>>4);
	blur_heightmap(heightmap3,width>>3,length>>3);
	merge_heightmap(heightmap2, heightmap3, 0.1, width>>2,length>>2,width>>3,length>>3);
	blur_heightmap(heightmap2,width>>2,length>>2);
	//merge_heightmap(heightmap, heightmap3, 0.01, width,length,width>>2,length>>2);
	//merge_heightmap(heightmap, heightmap2, 0.01, width,length,width>>1,length>>1);
	merge_heightmap(heightmap, heightmap2, 0.1, width,length,width>>2,length>>2);

	blur_heightmap(heightmap,width,length);
	//blur_heightmap(heightmap,width,length);
	//blur_heightmap(heightmap,width,length);
	delete heightmap2;
	delete heightmap3;
	delete heightmap4;


	this->width = width;
	this->length = length;
	this->heightmap = heightmap;
	this->listable = false;

	//Vertices allocation
	int nb_vertices = width*length*6;
	this->vertexcount = nb_vertices;

	this->texcoords = new float[nb_vertices * 2];
	this->texcoordscount = nb_vertices;
	this->vertices = new float*[nb_vertices];
	for (i =0;i < nb_vertices;i++)
		this->vertices[i] = new float[3];

	//Faces allocation
	this->facecount = (width-1)*(length-1)*2;
	printf("Face count: %d\n",this->facecount);

	this->arrayface = new face[facecount];
	for (int i = 0 ; i <facecount;i++)
	{
		this->arrayface[i].nbvertices = 3;
		this->arrayface[i].nbtextures = 0;
	}

	/*
	this->facesindex = new int*[this->facecount];
	for (i = 0;i < this->facecount;i++)
		this->facesindex[i] = new int[3];
	*/


	//unsigned max = 3;
	unsigned short max = heightmap_max(heightmap,width,length);
	printf("max= %d\n",max);
	//int max = 1;
	int facecounter = 0;
	for (i = 0;i < width-1;i++)
	  for(j = 0;j < length-1;j++){
	     float deniv = 6.;

		int offset =  (i+j*length)*6;
	    this->vertices[offset][0] = (float)i-(width/2);
	    this->vertices[offset][1] = (float)j-(length/2);
	    this->vertices[offset][2] = ((float)heightmap[i+j*length]/max)*deniv;

		this->texcoords[offset*2] = 1./(float)width * i;
		this->texcoords[offset*2+1] = 1./(float)width * j;

	    //this->vertices[(i+j*length)*6][2] = deniv;
	    //this->vertices[(i+j*length)*6][3] = heightmap[i+j*length]/(float)max;


	    this->vertices[offset+1][0] = (float)i+1-(width/2);
	    this->vertices[offset+1][1] = (float)j-(length/2);
	    this->vertices[offset+1][2] = ((float)heightmap[i+1+j*length]/max)*deniv;

		this->texcoords[(offset+1)*2] = 1./(float)width * (i+1);
		this->texcoords[(offset+1)*2+1] = 1./(float)width * j;

 	    //this->vertices[(i+j*length)*6+1][2] = deniv;
	    //this->vertices[(i+j*length)*6+1][3] = heightmap[i+1+j*length]/(float)max;



	    this->vertices[offset+2][0] = (float)i+1-(width/2);
	    this->vertices[offset+2][1] = (float)j+1-(length/2);
	    this->vertices[offset+2][2] = (float)heightmap[i+1+(j+1)*length]/max*deniv;
   	    //this->vertices[(i+j*length)*6+2][2] = deniv;
	    //this->vertices[(i+j*length)*6+2][3] = heightmap[i+1+(j+1)*length]/(float)max;

		this->texcoords[(offset+2)*2] = 1./(float)width * (i+1);
		this->texcoords[(offset+2)*2+1] = 1./(float)width * (j+1);


		 this->arrayface[facecounter].vertexindex[0] = (i+j*length)*6;
		 this->arrayface[facecounter].vertexindex[1]  = (i+j*length)*6 + 1;
		 this->arrayface[facecounter].vertexindex[2] = (i+j*length)*6 + 2;
	    /*
		this->facesindex[facecounter][0]  = (i+j*length)*6;
		this->facesindex[facecounter][1]  = (i+j*length)*6 + 1;
		this->facesindex[facecounter][2]  = (i+j*length)*6 + 2;
		*/
			this->arrayface[facecounter].nbvertices = 3;
	facecounter++;



	    this->vertices[offset+3][0] = (float)i+1-(width/2);
	    this->vertices[offset+3][1] = (float)j+1-(length/2);
	    this->vertices[offset+3][2] = (float)heightmap[i+1+(j+1)*length]/max*deniv;

	    //this->vertices[(i+j*length)*6+3][2] = deniv;
	   // this->vertices[(i+j*length)*6+3][3] = heightmap[i+1+(j+1)*length]/(float)max;
		this->texcoords[(offset+3)*2] = 1./(float)width * (i+1);
		this->texcoords[(offset+3)*2+1] = 1./(float)width * (j+1);



	    this->vertices[offset+4][0] = (float)i-(width/2);
	    this->vertices[offset+4][1] = (float)j+1-(length/2);
	    this->vertices[offset+4][2] = (float)heightmap[i+(j+1)*length]/max*deniv;
	    //this->vertices[(i+j*length)*6+4][2] = deniv;
	    //this->vertices[(i+j*length)*6+4][3] = heightmap[i+(j+1)*length]/(float)max;
		this->texcoords[(offset+4)*2] = 1./(float)width * i;
		this->texcoords[(offset+4)*2+1] = 1./(float)width * (j+1);



	    this->vertices[offset+5][0] = (float)i-(width/2);
	    this->vertices[offset+5][1] = (float)j-(length/2);
	    this->vertices[offset+5][2] = (float)heightmap[i+j*length]/max*deniv;

		this->texcoords[(offset+5)*2] = 1./(float)width * i;
		this->texcoords[(offset+5)*2+1] = 1./(float)width * j;

	    //this->vertices[(i+j*length)*6+5][2] = deniv;
	    //this->vertices[(i+j*length)*6+5][3] = heightmap[i+j*length]/(float)max;
	    /*
		this->facesindex[facecounter][0]  = (i+j*length)*6 + 3;
		this->facesindex[facecounter][1]  = (i+j*length)*6 + 4;
		this->facesindex[facecounter][2]  = (i+j*length)*6 + 5;
		*/
		 this->arrayface[facecounter].vertexindex[0] = (i+j*length)*6 + 3;
		 this->arrayface[facecounter].vertexindex[1]  = (i+j*length)*6 + 4;
		 this->arrayface[facecounter].vertexindex[2] = (i+j*length)*6 + 5;
		this->arrayface[facecounter].nbvertices = 3;
	facecounter++;
//printf("facecount: %d\n",	facecounter);
	  }



	int countmerged = 0;
	for (int i = 0;i < this->facecount;i++)
		{
			for (int j = 0;j < 3;j++)
			{
				int index = this->arrayface[i].vertexindex[j];
				for (int l = 0;l < index;l++)
				{
					if (this->vertices[index][0] == this->vertices[l][0])
							if (this->vertices[index][1] == this->vertices[l][1])
								if (this->vertices[index][2] == this->vertices[l][2])
								{
									//printf("%d = %d\n",index,l );
									//printf("removing %d\n",index);
									this->arrayface[i].vertexindex[j] = l;

									countmerged++;
									break;
								}
					}
			}
		}

	printf("terrain: %d vertices merged\n",countmerged);

	//Normal allocation and compuation
	//this->normals = new float*[this->facecount];
	/*
	for (i = 0;i < this->facecount;i++)
	{
	//printf("%d: %d %d %d\n",i,this->arrayface[i].vertexindex[0],this->arrayface[i].vertexindex[1],this->arrayface[i].vertexindex[2]);
		//this->arrayface[i].n = new float[3];
		vector3f res;
		vector3f vm1;
		vector3f vm2;
		vector3f v0 = vector3f(this->vertices[ this->arrayface[i].vertexindex[0]]);
		vector3f v1 = vector3f(this->vertices[ this->arrayface[i].vertexindex[1]]);
		vector3f v2 = vector3f(this->vertices[ this->arrayface[i].vertexindex[2]]);
		vector3f::sub(vm1,v1,v0);
		vector3f::sub(vm2,v2,v0);
		vector3f::vect(res,vm1,vm2);
		res.normalize();

		this->arrayface[i].normal[0] = res(0);
		this->arrayface[i].normal[1]  = res(1);
		this->arrayface[i].normal[2]  = res(2);

		//res.print();

	}
	*/
	this->orientation[0]  = 100.;

	this->generate_texture(32,32);
	this->settexture(this->texturepixels,32,32);

	this->facegroupcount = 0;
	//this->texcoordscount = 0;

	this->facegroupcount = 1;
	this->arrayfacegroup = new FaceGroup[1];
	this->arrayfacegroup[0].uVertBufferOffset =this->vertexcount;
	this->arrayfacegroup[0].verticesCount = this->vertexcount;
	this->arrayfacegroup[0].uFaceIndexBufferOffset = this->facecount;
	this->arrayfacegroup[0].faceCount = this->facecount;
	this->arrayfacegroup[0].verticesPerFace = 3;
	this->arrayfacegroup[0].texturesCount = 0;
	this->arrayfacegroup[0].uTexCoordsBuffer = 0;
	this->arrayfacegroup[0].texCoordsLayerCount = 0;
	this->arrayfacegroup[0].texCoordsCount = 0;
	this->arrayfacegroup[0].texcoordsBufferName = 0;
	this->arrayfacegroup[0].colorBufferName = 0;
	this->arrayfacegroup[0].useShader = false;
	this->arrayfacegroup[0].hasNormalMap = false;
	this->arrayfacegroup[0].hasTexture = false;





    this->normals =new float*[this->vertexcount];
    for (int k = 0;k < this->vertexcount;k++)
    {
	       this->normals[k] = new float[3];
	       this->normals[k][0] = 0.;
	       this->normals[k][1] = 0.;
	       this->normals[k][2] = 0.;
   }

       this->binormals =new float*[this->vertexcount];
       for (int k = 0;k < this->vertexcount;k++)
       {
	       this->binormals[k] = new float[3];
	       this->binormals[k][0] = 0.;
	       this->binormals[k][1] = 0.;
	       this->binormals[k][2] = 0.;
       }

        this->tangents =new float*[this->vertexcount];
       for (int k = 0;k < this->vertexcount;k++)
       {
	       this->tangents[k] = new float[3];
	       this->tangents[k][0] = 0.;
	       this->tangents[k][1] = 0.;
	       this->tangents[k][2] = 0.;
       }
    for (int i = 0;i < this->facecount;i++)
    {
		computeLocalSpace2(&this->arrayface[i],this->vertices, this->normals,this->binormals, this->tangents);
    }

    for (int k = 0;k < this->vertexcount;k++)
    {



    	   /*
	       this->normals[k][0] = this->normals[k][0]/3.;
	       this->normals[k][1] = this->normals[k][1]/3.;
	       this->normals[k][2] = this->normals[k][2]/3.;
    	   */
    	   vector3f n = vector3f(this->normals[k]);
    	   //if (n.length() > 1.)
    	   //printf("length: %f\n",n.length());

    	   n.normalize();
 	       this->normals[k][0] = n(0);
	       this->normals[k][1] = n(1);
	       this->normals[k][2] = n(2);
   }
}


void terrain::settexture(unsigned char * pixels,int w ,int h)
{

  this->texture= new image24(pixels,w,h);
  EI_gen_textures(1,&this->texture_id);
	printf("texture %d",this->texture_id);
  EI_bind_2D_texture(this->texture_id);
  EI_tex_image2d24(this->texture->get_pixels(),
                  this->texture->get_width(),
                  this->texture->get_heigth(),
                this->texture_id);
	for (int i = 0;i < facecount;i++)
	{
		this->arrayface[i].textureids[this->arrayface[i].nbtextures] = this->texture_id;
		this->arrayface[i].nbtextures++;
	}
}




void terrain::settexture(char * filename)
{

  this->texture= new image24(filename);
  EI_gen_textures(1,&this->texture_id);
	printf("texture %d",this->texture_id);
  EI_bind_2D_texture(this->texture_id);
  EI_tex_image2d24(this->texture->get_pixels(),
                  this->texture->get_width(),
                  this->texture->get_heigth(),
                this->texture_id);
	for (int i = 0;i < facecount;i++)
	{
		this->arrayface[i].textureids[this->arrayface[i].nbtextures] = this->texture_id;
		this->arrayface[i].nbtextures++;
	}
}


void terrain::draw(void)
{
  //printf("nb v:%d\n",this->nb_vertices);
  //EI_setcolor(1.,1.0,1.0);
  /*
  for (int i = 0;i < int(this->nb_vertices/3);i++){
    EI_begin_triangle();
    EI_vertex(this->vertices[i*3][0],this->vertices[i*3][1],this->vertices[i*3][2]);
    EI_vertex(this->vertices[i*3+1][0],this->vertices[i*3+1][1],this->vertices[i*3+1][2]);
    EI_vertex(this->vertices[i*3+2][0],this->vertices[i*3+2][1],this->vertices[i*3+2][2]);
    EI_end();
  }
  */
	/*
   float color = 0.1;
 EI_begin_triangle();
  unsigned short max = heightmap_max(this->heightmap,this->width,this->length);
 for (int i = 0;i < int(this->nb_vertices);i++){
 //EI_setcolor(0.,this->vertices[i][2]/2.0,0);

 EI_setcolor(0,this->vertices[i][3],0);
  EI_vertex(this->vertices[i][0],this->vertices[i][1],this->vertices[i][2]);
 color += 0.1;
 if (color > 1.0)
   color = 0.;
}
 EI_end();
*/
}


terrain::~terrain()
{
	delete this->vertices;
}

void terrain::set_id(int id)
{
  this->id = id;
}

float * terrain::terrain::get_vertex(int i)
{
  return this->vertices[i];
}

int terrain::get_nb_vertices()
{
  return this->vertexcount;
}
