#include "tetraedra.h"
#include "ei.h"

tetraedra::tetraedra(float size,float x,float y,float z) : mobile(0.,x,y,z)
{
  this->size = size;
  this->vertices[0][0] = 0.;
  this->vertices[0][1] = 1.;
  this->vertices[0][2] = 0;

  this->vertices[1][0] = -1.;
  this->vertices[1][1] = -1.;
  this->vertices[1][2] = 0.;

  this->vertices[2][0] = 1.;
  this->vertices[2][1] = -1.;
  this->vertices[2][2] = 0.;

  this->vertices[3][0] = +1./2.;
  this->vertices[3][1] = -1./2.;
  this->vertices[3][2] = 1.; 

}


void tetraedra::draw(void)
{
  EI_scale(0.5,0.5,0.5);
  EI_begin_triangle();
  //EI_normal(0,0,-1);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);

  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);

  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);

  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);


  //EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
/*
  EI_normal(0,0,1);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 

  EI_normal(1,0,0);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);

  EI_normal(0,-1,0);  
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]); 

EI_normal(-1,0,0); 
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]); 

  EI_normal(0,1,0); 
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 
*/
  EI_end();

}

void tetraedra::render(){      
      if (this->is_listable()){
        EI_scale(this->size,this->size,this->size);
        EI_setcolor(this->color[0],this->color[1],this->color[2]);
        EI_call_list(this->get_idlist());
      }
      else {
        EI_scale(this->size,this->size,this->size);
        EI_setcolor(this->color[0],this->color[1],this->color[2]);
           this->draw();
           } 
}
void tetraedra::rotate(void)
{
       //EI_push_matrix();
       EI_translate(this->get_position()[0],
                  this->get_position()[1],
                  this->get_position()[2]);      
}
void tetraedra::translate(void)
{
         EI_rotate(this->get_orientation()[0],
                this->get_orientation()[1],
                this->get_orientation()[2]); 
           
}
void tetraedra::set_color(float r, float g, float b){
  this->color[0] = r;
  this->color[1] = g;
  this->color[2] = b;
  
}
