#include "image.h"
#include "image24.h"
#include "texturedcube.h"


#include <stdio.h>
#include "ei.h"

#include "vector3f.h"
#include "face.h"
/*
void EI_begin_quad(void);
void EI_setcolor(float r,float g,float b);
void EI_vertex(float x,float y,float z);
void EI_end(void);
void EI_gen_textures(int n,unsigned int * textures_names);
void EI_bind_2D_texture(unsigned int texture_name);
void EI_tex_image2d(unsigned char * pixels,int w,int h,int texture_name);
void EI_texcoord_i(int x,int y);
*/


texturedcube::texturedcube(float size,float x,float y,float z) : cube(size,x,y,z)
{
/*
       this->vertices[0][0] = x-size/2.;
       this->vertices[0][1] = y-size/2.;
       this->vertices[0][2] = z-size/2.;

       this->vertices[1][0] = x-size/2.;
       this->vertices[1][1] = y+size/2.;
       this->vertices[1][2] = z-size/2.;

       this->vertices[2][0] = x+size/2.;
       this->vertices[2][1] = y+size/2.;
       this->vertices[2][2] = z-size/2.;

       this->vertices[3][0] = x+size/2.;
       this->vertices[3][1] = y-size/2.;
       this->vertices[3][2] = z-size/2.; 

       this->vertices[4][0] = x-size/2.;
       this->vertices[4][1] = y-size/2.;
       this->vertices[4][2] = z+size/2.;

       this->vertices[5][0] = x-size/2.;
       this->vertices[5][1] = y+size/2.;
       this->vertices[5][2] = z+size/2.;

       this->vertices[6][0] = x+size/2.;
       this->vertices[6][1] = y+size/2.;
       this->vertices[6][2] = z+size/2.;

       this->vertices[7][0] = x+size/2.;
       this->vertices[7][1] = y-size/2.;
       this->vertices[7][2] = z+size/2.;  
*/     

       this->vertices[0][0] = -size/2.;
       this->vertices[0][1] = -size/2.;
       this->vertices[0][2] = -size/2.;

       this->vertices[1][0] = -size/2.;
       this->vertices[1][1] = +size/2.;
       this->vertices[1][2] = -size/2.;

       this->vertices[2][0] = +size/2.;
       this->vertices[2][1] = +size/2.;
       this->vertices[2][2] = -size/2.;

       this->vertices[3][0] = +size/2.;
       this->vertices[3][1] = -size/2.;
       this->vertices[3][2] = -size/2.; 

       this->vertices[4][0] = -size/2.;
       this->vertices[4][1] = -size/2.;
       this->vertices[4][2] = +size/2.;

       this->vertices[5][0] = -size/2.;
       this->vertices[5][1] = +size/2.;
       this->vertices[5][2] = +size/2.;

       this->vertices[6][0] = +size/2.;
       this->vertices[6][1] = +size/2.;
       this->vertices[6][2] = +size/2.;

       this->vertices[7][0] = +size/2.;
       this->vertices[7][1] = -size/2.;
       this->vertices[7][2] = +size/2.;  

	this->vertexcount = 8; 

/*
	for (int i = 0;i < this->vertexcount;i++)
	{
		printf("vertex %d %f %f %f\n",i,this->vertices[i][0],this->vertices[i][1],this->vertices[i][2]);			
	}       
*/
       
       this->listable = false;   

       
/*
       this->faces[0] = {0,1,2};
       this->faces[1] = {2,3,0};       
       
       this->faces[2] = {4,7,6};
       this->faces[3] = {6,5,4};    
       
       this->faces[4] = {3,2,6};
       this->faces[5] = {6,7,3};        
       
       
       this->faces[6] = {0,3,7};
       this->faces[7] = {7,4,0};  
       
       this->faces[8] = {4,5,1};
       this->faces[9] = {1,0,4};

       this->faces[10] = {6,2,1};
       this->faces[11] = {1,5,6};       
*/

       this->facecount = 6;
       
       this->arrayface = new face[6];
       
       //this->facesindex =new int*[6];
       //for (int k = 0;k < 6;k++)
	      // this->facesindex[k] = new int[4];	

	const int f0[4] = {0,1,2,3};
	const int f1[4] = {4,7,6,5};
	const int f2[4] = {3,2,6,7};
	const int f3[4] = {0,3,7,4};
	const int f4[4] = {4,5,1,0};
	const int f5[4] = {6,2,1,5};
	
	
	this->arrayface[0].nbvertices = 4;
	this->arrayface[1].nbvertices = 4;
	this->arrayface[2].nbvertices = 4;
	this->arrayface[3].nbvertices = 4;	
	this->arrayface[4].nbvertices = 4;		
	this->arrayface[5].nbvertices = 4;
	this->arrayface[0].nbtextures = 0;
	this->arrayface[1].nbtextures = 0;
	this->arrayface[2].nbtextures = 0;
	this->arrayface[3].nbtextures = 0;
	this->arrayface[4].nbtextures = 0;
	this->arrayface[5].nbtextures = 0;	
	
	for (int i =0;i < 4;i++)
	{
		this->arrayface[0].vertexindex[i] = f0[i];
		this->arrayface[1].vertexindex[i] = f1[i];
		this->arrayface[2].vertexindex[i] = f2[i];
		this->arrayface[3].vertexindex[i] = f3[i];		
		this->arrayface[4].vertexindex[i] = f4[i];
		this->arrayface[5].vertexindex[i] = f5[i];		
	}       

	this->texcoords = new float[8*6];

	for (int i = 0;i < 6;i++)
	{
		this->texcoords [6+i*6] = 0.;
		this->texcoords [7+i*6] = 0.;
		this->texcoords [4+i*6] = 1.;
		this->texcoords [5+i*6] = 0.;		
		this->texcoords [2+i*6] = 1.;
		this->texcoords [3+i*6] = 1.;
		this->texcoords [0+i*6] = 0.;
		this->texcoords [1+i*6] = 1.;		
	}
		
		/*
		texcoord[8] = 0.;
		texcoord[9] = 0.;
		texcoord[10] = 1.;
		texcoord[11] = 0.;		
		texcoord[12] = 1.;
		texcoord[13] = 1.;
		texcoord[14] = 0.;
		texcoord[15] = 1.;
		*/	
	
	/*
       this->normals =new float*[6];
       for (int k = 0;k < 6;k++)
	       this->normals[k] = new float[3];	
	*/
       
       for (int i = 0;i < 6;i++)
       {
/*
		this->arrayface[i].texCoords[0] = 0.;
		this->arrayface[i].texCoords[1] = 0.;
		this->arrayface[i].texCoords[2] = 1.;
		this->arrayface[i].texCoords[3] = 0.;		
		this->arrayface[i].texCoords[4] = 1.;
		this->arrayface[i].texCoords[5] = 1.;
		this->arrayface[i].texCoords[6] = 0.;
		this->arrayface[i].texCoords[7] = 1.;	
*/	
/*	       
		this->arrayface[i].texCoords[0] = 0.;
		this->arrayface[i].texCoords[1] = 0.;
		this->arrayface[i].texCoords[2] = 0.;
		this->arrayface[i].texCoords[3] = 1.;		
		this->arrayface[i].texCoords[4] = 1.;
		this->arrayface[i].texCoords[5] = 1.;
		this->arrayface[i].texCoords[6] = 1.;
		this->arrayface[i].texCoords[7] = 0.;	       
*/	       

		this->arrayface[i].texCoords[6] = 0.;
		this->arrayface[i].texCoords[7] = 0.;
		this->arrayface[i].texCoords[4] = 1.;
		this->arrayface[i].texCoords[5] = 0.;		
		this->arrayface[i].texCoords[2] = 1.;
		this->arrayface[i].texCoords[3] = 1.;
		this->arrayface[i].texCoords[0] = 0.;
		this->arrayface[i].texCoords[1] = 1.;	

	       
		//computeNormal(&this->arrayface[i],this->vertices);
	       
	      computeLocalSpace2(&this->arrayface[i],this->vertices, this->normals,this->binormals, this->tangents);
	       
	       //computeLocalSpace2(face * pface, float **vertexbuffer, float **normalbuffer,float **binormalbuffer, float **tangentbuffer)
       }
       
       /*
       for (int i = 0; i < 8;i++)
       {
		vector3f v;
		v = vector3f(this->normals[i]);
		v.normalize();
	       //v.print();
	       this->normals[i][0] = v(0);
	       this->normals[i][1] = v(1);
	       this->normals[i][2] = v(2);	       
	       
		computeLocalSpaceVertex(this->normals[i], this->binormals[i],  this->tangents[i]);
	       
		v = vector3f(this->binormals[i]);
		v.normalize();
	       this->binormals[i][0] = v(0);
	       this->binormals[i][1] = v(1);
	       this->binormals[i][2] = v(2);	
	       
		v = vector3f(this->tangents[i]);
		v.normalize();
	       this->tangents[i][0] = v(0);
	       this->tangents[i][1] = v(1);
	       this->tangents[i][2] = v(2);		       
	       
       }
       */
       
	       
       //puts("-->Normals");
       for (int i = 0;i < 8;i++)
       {
		vector3f v;
		v = vector3f(this->normals[i]);
		v.normalize();
	       //v.print();
	       this->normals[i][0] = v(0);
	       this->normals[i][1] = v(1);
	       this->normals[i][2] = v(2);

		v = vector3f(this->binormals[i]);
		v.normalize();
	       this->binormals[i][0] = v(0);
	       this->binormals[i][1] = v(1);
	       this->binormals[i][2] = v(2);	
	       
		v = vector3f(this->tangents[i]);
		v.normalize();
	       this->tangents[i][0] = v(0);
	       this->tangents[i][1] = v(1);
	       this->tangents[i][2] = v(2);		       
	       
       }
       // puts("<--Normals");      
       
       
     /* 
 this->normals[0][0] = 0.;       
this->normals[0][1] = 0.;       
this->normals[0][2] = 1.;       


   this->normals[1][0] = 0.;       
   this->normals[1][1] = 0.;       
   this->normals[1][2] = -1.;       

   this->normals[2][0] = -1.;       
   this->normals[2][1] = 0.;       
   this->normals[2][2] = 0.;       

   this->normals[3][0] = 0.;       
   this->normals[3][1] = 1.;       
   this->normals[3][2] = 0.;       

   this->normals[4][0] = 1.;       
   this->normals[4][1] = 0.;       
   this->normals[4][2] = 0.;       

   this->normals[5][0] = 0.;       
   this->normals[5][1] = -1.;       
   this->normals[5][2] = 0.;            
      */
       
 /*      
this->normals[0][0] = 0.;       
this->normals[0][1] = 0.;       
this->normals[0][2] = -1.;       


   this->normals[1][0] = 0.;       
   this->normals[1][1] = 0.;       
   this->normals[1][2] = 1.;       

   this->normals[2][0] = 1.;       
   this->normals[2][1] = 0.;       
   this->normals[2][2] = 0.;       

   this->normals[3][0] = 0.;       
   this->normals[3][1] = -1.;       
   this->normals[3][2] = 0.;       

   this->normals[4][0] = -1.;       
   this->normals[4][1] = 0.;       
   this->normals[4][2] = 0.;       

   this->normals[5][0] = 0.;       
   this->normals[5][1] = 1.;       
   this->normals[5][2] = 0.;       	
   */
}

texturedcube::~texturedcube()
{
}

void texturedcube::settexture(char * filename, int idface)

{
  this->textures[idface] = new image24(filename);
  //int i = this->textures_id[idface];

  //EI_gen_textures(1,&this->textures_id[idface]);
	EI_gen_textures(1,&this->arrayface[idface].textureids[this->arrayface[idface].nbtextures]);

  /*

  int nb = 0;

  printf("Texture %d name: %d\n",idface,this->textures_id[idface]);

  printf("Texture width: %d\n",this->textures[idface]->get_width());

  printf("Texture heigth: %d\n",this->textures[idface]->get_heigth());

  for (int i = 0; i < this->textures[idface]->get_width()*this->textures[idface]->get_heigth()*3;i++){

    nb += (int)this->textures[idface]->get_pixels()[i];

  }

  printf("nb: %d\n",nb);*/    
  

  EI_bind_2D_texture(this->arrayface[idface].textureids[this->arrayface[idface].nbtextures]);
  EI_tex_image2d24(this->textures[idface]->get_pixels(),
                this->textures[idface]->get_width(),
                this->textures[idface]->get_heigth(),
                this->arrayface[idface].textureids[this->arrayface[idface].nbtextures]);
		this->arrayface[idface].nbtextures++;	
//this->arrayface[idface].nbtextures++;
  //printf("settexture: %d",this->arrayface[idface].nbtextures);
  delete this->textures[idface] ;
}

void texturedcube::draw(void)

{
	/*
 EI_setcolor(1.,1.,1.);
  EI_bind_2D_texture(this->textures_id[0]);

 

  EI_begin_quad();

  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);

  EI_end();  
  
  EI_bind_2D_texture(this->textures_id[1]); 

 // EI_setcolor(1.,1.,1.);
  
  EI_begin_quad(); 

  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 

  EI_end();
  EI_bind_2D_texture(this->textures_id[2]);


//  EI_setcolor(1.,1.,1.);

  EI_begin_quad();

  EI_texcoord_i(0,0);  
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  EI_end();  

  EI_bind_2D_texture(this->textures_id[3]);  

//  EI_setcolor(1.,1.,1.);
  EI_begin_quad();

  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[7][0],this->vertices[7][1],this->vertices[7][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]); 

  EI_end();    

  EI_bind_2D_texture(this->textures_id[4]);

//  EI_setcolor(1.,1.,1.);
  EI_begin_quad();

/*
  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[3][0],this->vertices[3][1],this->vertices[3][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]); 
*/
/*
  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[4][0],this->vertices[4][1],this->vertices[4][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[0][0],this->vertices[0][1],this->vertices[0][2]); 

  EI_end();    

  EI_bind_2D_texture(this->textures_id[5]);

//  EI_setcolor(1.,1.,1.);
  EI_begin_quad();

  EI_texcoord_i(0,0);
  EI_vertex(this->vertices[6][0],this->vertices[6][1],this->vertices[6][2]);
  EI_texcoord_i(1,0);
  EI_vertex(this->vertices[2][0],this->vertices[2][1],this->vertices[2][2]);
  EI_texcoord_i(1,1);
  EI_vertex(this->vertices[1][0],this->vertices[1][1],this->vertices[1][2]);
  EI_texcoord_i(0,1);
  EI_vertex(this->vertices[5][0],this->vertices[5][1],this->vertices[5][2]); 

  EI_end();
  */
}

